// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;
using System.Timers;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace AsReaderGun251GDemoApp
{
    public partial class BarcodeDemoViewController : UIViewController
    {
        readonly SystemSetting systemSetting = SystemSetting.sharedSystemSetting();
        readonly AppDelegate appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;

        bool isScanTimerEnable;

        readonly string[] rescanTimePickerData = {"Not Used", "100 ms", "200 ms", "300 ms", "400 ms", "500 ms", "600 ms", "700 ms",
             "800 ms", "900 ms", "1000 ms", "1100 ms", "1200 ms", "1300 ms",
            "1500 ms", "2000 ms", "2500 ms", "3000 ms", "3500 ms", "5000 ms","10000 ms"};
        readonly string[] rescanTimeData = {"0", "100", "200", "300", "400", "500",
             "600", "700", "800", "900", "1000", "1100", "1200", "1300", "1500", "2000", "2500", "3000",
            "3500", "5000","10000"};

        int rescanTimeValue;

        NSDateFormatter formatter = new NSDateFormatter();

        NSStringEncoding encoding;

        NSMutableArray barcodeArray = new NSMutableArray();

        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public BarcodeDemoViewController(IntPtr handle) : base(handle)
        {
        }
        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            encoding = NSStringEncoding.ASCIIStringEncoding;
            encodingSegment.SelectedSegment = 0;
            rescanTimeTextField.Text = rescanTimePickerData[systemSetting.getBarcodeReScanTime()];
            rescanTimeValue = systemSetting.getBarcodeReScanTime();
            AppDelegate.showGlobalProgressHUDWithTitle("Loading...");


            try
            {
                if (systemSetting.getBarcodeData().Count != 0)
                {
                    barcodeArray = (NSMutableArray)systemSetting.getBarcodeData();
                }
            }
             catch (Exception ex)
            {
                UIAlertController alert = UIAlertController.Create("Error", ex.ToString(), UIAlertControllerStyle.Alert);
                alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
                PresentViewController(alert, true, null);
            }
           

            totalCountLabel.Text = barcodeArray.Count.ToString();
            AppDelegate.showGlobalProgressHUDWithTitle("Loading...");

            formatter.DateStyle = NSDateFormatterStyle.Medium;
            formatter.TimeStyle = NSDateFormatterStyle.Short;
            formatter.DateFormat = "YYYY/MM/dd HH:mm:ss";

            pickerView.DataSource = new MyPickerViewDataSource(this);
            pickerView.Delegate = new MyPickerViewDelegate(this);
            tableView.DataSource = new MyTableViewSource(this);
            tableView.Delegate = new MyTableViewDelegate(this);

            if (mReader == null) return;
        }
        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
            mReader.SetScanMode(ScanMode.BarcodeScanMode);
            gunManager.onAsReaderGUNDisconnected = () =>
            {
                AppDelegate.dismissGlobalHUD();
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };
            gunManager.onAsReaderGUNConnected = () =>
            {
                ViewDidAppear(true);
            };
            gunManager.onAsReaderTriggerKeyEvent = (status) =>
            {
                setScanTimeEnable(status);
                scanEnabled(status);
                return false;
            };
            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };
            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };

            gunManager.updateDeviceState = (error) =>
            {
                if (error != ResultCode.NoError)
                {
                    UIAlertController alert = UIAlertController.Create("Error", "Failed to get response. Try again.", UIAlertControllerStyle.Alert);
                    alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
                    PresentViewController(alert, true, null);
                    PerformSelector(new ObjCRuntime.Selector("pop2"), null, 1);
                }
            };

            gunManager.changedActionState = (action, resultCode) =>
            {
                if (action == CommandType.Stop && isScanTimerEnable == true)
                {
                    int rescanTime = int.Parse(rescanTimeData[rescanTimeValue]);
                    if (rescanTime > 0)
                    {
                        CancelPreviousPerformRequest(this, new ObjCRuntime.Selector("startDecoder"), null);
                        PerformSelector(new ObjCRuntime.Selector("startDecoder"), null, rescanTime / 1000.00);
                    }
                    else
                        scanElemEnabled(true);
                }
            };

            gunManager.detectBarcodeData = (barcodeType, codeId, barcodeData) =>
            {
                hwTriggerBtn.SetTitle("Reset Scan", UIControlState.Normal);
                NSString barcode = new NSString();
                try
                {
                    barcode = new NSString(barcodeData, encoding);
                }
                catch
                {
                    try
                    {
                        barcode = new NSString(barcodeData, NSStringEncoding.ASCIIStringEncoding);
                    }
                    catch
                    {
                        return;
                    }
                }
                if (barcode == null)
                {
                    barcode = new NSString(barcodeData, NSStringEncoding.ASCIIStringEncoding);
                }
                try
                {
                    bool isNew = true;
                    for (nuint i = 0; i < barcodeArray.Count; i++)
                    {
                        AsBarcodeItem barcodeTtem = barcodeArray.GetItem<AsBarcodeItem>(i);
                        if (barcodeTtem.barcode == barcode && barcodeTtem.codeId == codeId)
                        {
                            isNew = false;
                            barcodeTtem.count = (int.Parse(barcodeTtem.count) + 1).ToString();
                            barcodeArray.ReplaceObject((nint)i, barcodeTtem);
                            break;
                        }
                    }

                    if (isNew)
                    {
                        AsBarcodeItem item = new AsBarcodeItem();
                        item.barcodeType = barcodeType;
                        item.codeId = codeId;
                        item.barcode = barcode;
                        item.count = "1";
                        item.dateTime = formatter.ToString(NSDate.Now);
                        barcodeArray.Add(item);
                    }
                    NSArray array = (NSArray)barcodeArray;
                    systemSetting.setBarcodeData(array);
                    tableView.ReloadData();
                    NSIndexPath indexPath = NSIndexPath.FromRowSection((nint)barcodeArray.Count - 1, 0);
                    tableView.ScrollToRow(indexPath, UITableViewScrollPosition.Bottom, true);
                    totalCountLabel.Text = barcodeArray.Count.ToString();
                }
                catch
                {
                   
                }
            };
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }
        [Export("pop2")]
        void testPop2()
        {
            NavigationController.PopViewController(true);
        }
        public override void ViewDidAppear(bool animated)
        {
            mReader.SetBarcodeMode(true, true, systemSetting.getCustomPrefixSuffix());
            AppDelegate.dismissGlobalHUD();
            mReader.SetScanMode(ScanMode.BarcodeScanMode);
        }
        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();
            if (mReader != null)
            {
                mReader.SetScanMode(ScanMode.RFIDScanMode);
                mReader.SetBarcodeMode(false, false, systemSetting.getCustomPrefixSuffix());
            }
        }
        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }

        //#pragma mark - UITableViewDataSource
        private class MyTableViewSource : UITableViewDataSource
        {
            BarcodeDemoViewController currentViewContorller;
            public MyTableViewSource(BarcodeDemoViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint NumberOfSections(UITableView tableView)
            {
                return 1;
            }

            public override nint RowsInSection(UITableView tableView, nint section)
            {
                if (currentViewContorller.barcodeArray != null) return (nint)currentViewContorller.barcodeArray.Count;
                return 0;
            }

            public override UITableViewCell GetCell(UITableView tableView, NSIndexPath indexPath)
            {
                BarcodeDemoTableViewCell cell = (BarcodeDemoTableViewCell)tableView.DequeueReusableCell("BarcodeCell", indexPath);
                AsBarcodeItem item = currentViewContorller.barcodeArray.GetItem<AsBarcodeItem>((uint)indexPath.Row);
                if (item != null && cell != null)
                {
                    cell.codeTypeLabel.Text = AsBarcodeType.GetBarcodeString(item.barcodeType);
                    cell.codeIdLabel.Text = item.codeId;
                    cell.barcodeLabel.Text = item.barcode;
                    cell.countLabel.Text = item.count.ToString();
                }
                return cell;
            }
        }

        //#pragma mark - UITableViewDelegate
        private class MyTableViewDelegate : UITableViewDelegate
        {
            BarcodeDemoViewController currentViewContorller;
            public MyTableViewDelegate(BarcodeDemoViewController controller)
            {
                currentViewContorller = controller;
            }

            public override UITableViewCellEditingStyle EditingStyleForRow(UITableView tableView, NSIndexPath indexPath)
            {
                return UITableViewCellEditingStyle.Delete;
            }
        }
        //#pragma mark - UIPickerViewDataSource
        private class MyPickerViewDataSource : UIPickerViewDataSource
        {
            BarcodeDemoViewController currentViewContorller;
            public MyPickerViewDataSource(BarcodeDemoViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint GetComponentCount(UIPickerView pickerView)
            {
                return 1;
            }

            public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
            {
                return currentViewContorller.rescanTimePickerData.Length;
            }
        }

        //#pragma mark - UIPickerViewDelegate
        private class MyPickerViewDelegate : UIPickerViewDelegate
        {
            BarcodeDemoViewController currentViewContorller;
            public MyPickerViewDelegate(BarcodeDemoViewController controller)
            {
                currentViewContorller = controller;
            }

            public override string GetTitle(UIPickerView pickerView, nint row, nint component)
            {
                return currentViewContorller.rescanTimePickerData[row];
            }
        }

        //#pragma mark - IBActions
        partial void clearBtnTapped(NSObject sender)
        {
            barcodeArray.RemoveAllObjects();
            NSArray array = (NSArray)barcodeArray;
            systemSetting.setBarcodeData(array);
            tableView.ReloadData();
            totalCountLabel.Text = "0";
        }
        partial void scanStartBtnTapped(NSObject sender)
        {
            setScanTimeEnable(true);
            scanEnabled(true);
        }
        partial void scanStopBtnTapped(NSObject sender)
        {
            stopScan();
        }
        partial void scanHWTriggerStartBtnTapped(NSObject sender)
        {
            setScanTimeEnable(false);
            scanEnabled(false);
            UIButton btn = (UIButton)sender;
            string btnTitle = btn.TitleLabel.Text;
            if (btnTitle.IndexOf("Reset") > -1)
            {
                _ = mReader.StartHWTriggerDecode;
                btn.SetTitle("Stop Scan", UIControlState.Normal);
            }
            else
            {
                _ = mReader.StopHWTriggerDecode;
                btn.SetTitle("Reset Scan", UIControlState.Normal);
            }

        }

        partial void rescanTimeBtnTapped(NSObject sender)
        {
            pickerView.Hidden = false;
            pickerView.Select(rescanTimeValue, 0, false);
            rescanTimePickerTopView.Hidden = false;
        }
        partial void pickerCloseBtnTapped(NSObject sender)
        {
            hidePickerView();
        }
        partial void rescanTimePickerOkBtnTapped(NSObject sender)
        {
            int idx = (int)pickerView.SelectedRowInComponent(0);
            rescanTimeTextField.Text = rescanTimePickerData[idx];
            rescanTimeValue = idx;
            systemSetting.setBarcodeReScanTime(rescanTimeValue);
            hidePickerView();
        }

        partial void whenEncodingSegmentChanged(NSObject sender)
        {
            UISegmentedControl control = (UISegmentedControl)sender;
            switch (control.SelectedSegment)
            {
                case 0:
                    encoding = NSStringEncoding.ASCIIStringEncoding;
                    break;
                case 1:
                    encoding = NSStringEncoding.UTF8;
                    break;
                case 2:
                    encoding = NSStringEncoding.ShiftJIS;
                    break;
                default:
                    encoding = NSStringEncoding.ASCIIStringEncoding;
                    break;
            }
        }

        //#pragma mark - Custom
        void hidePickerView()
        {
            pickerView.Hidden = true;
            rescanTimePickerTopView.Hidden = true;
        }
        void setScanTimeEnable(bool isEnable)
        {
            isScanTimerEnable = isEnable;
            if (isEnable == false)
            {
                CancelPreviousPerformRequest(this, new ObjCRuntime.Selector("startDecoder"), null);
            }
        }
        void scanEnabled(bool enabled)
        {
            if (enabled)
            {
                ResultCode code = mReader.StartDecode;
                scanElemEnabled(false);
            }
            else
            {
                CancelPreviousPerformRequest(this, new ObjCRuntime.Selector("startDecoder"), null);
                ResultCode code = mReader.StopSync;
                scanElemEnabled(true);
            }
        }
        void scanElemEnabled(bool enabled)
        {
            if (enabled)
            {
                foreach (UIControl control in toDisableElems)
                {
                    control.Enabled = true;
                }
            }
            else
            {
                foreach (UIControl control in toDisableElems)
                {
                    control.Enabled = false;
                }
            }
        }

        [Export("startDecoder")]
        void startDecoder()
        {
            scanEnabled(true);
        }
        void stopScan()
        {
            CancelPreviousPerformRequest(this, new ObjCRuntime.Selector("startDecoder"), null);
            setScanTimeEnable(false);
            scanEnabled(false);
        }
        internal class unint
        {
        }
    }
}