// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;

namespace AsReaderGun251GDemoApp
{
    public partial class BarcodeOption_VC : UIViewController
    {
        readonly int PICKER_VIEW_BUZZER = 0;
        readonly int PICKER_VIEW_Vibrator = 1;

        readonly SystemSetting systemSetting = SystemSetting.sharedSystemSetting();
        readonly AppDelegate appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;

        readonly string[] buzzerPickerData = { "Off", "Low", "High" };
        readonly string[] vibratorPickerData = { "Off", "On" };

        BuzzerState buzzerValue;
        VibratorState vibratorValue;

        string batteryIntervalValue;
        int sleepTimeValue;

        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public BarcodeOption_VC(IntPtr handle) : base(handle)
        {
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            scrollView.ContentSize = new CoreGraphics.CGSize(0, 1000);
            scrollView.ShowsVerticalScrollIndicator = false;
            pickerView.DataSource = new MyPickerViewDataSource(this);
            pickerView.Delegate = new MyPickerViewDelegate(this);
        }
        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
            gunManager.onAsReaderGUNDisconnected = () => {
                AppDelegate.dismissGlobalHUD();
                hidePickerView();
                hideTableView();
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };
            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };
            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };
        }
        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
            if (mReader == null) return;
            AppDelegate.showGlobalProgressHUDWithTitle("Loading...");

            vibratorValue = mReader.Vibrator;
            buzzerValue = mReader.Buzzer;
            sleepTimeValue = mReader.SleepTime;
            initViewData();
            NavigationController.View.AddSubview(shadowView);
            AppDelegate.dismissGlobalHUD();
        }
        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();
        }
        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }
//#pragma mark - UIPickerViewDelegate
        private class MyPickerViewDelegate : UIPickerViewDelegate
        {
            BarcodeOption_VC currentViewContorller;
            public MyPickerViewDelegate(BarcodeOption_VC controller)
            {
                currentViewContorller = controller;
            }

            public override string GetTitle(UIPickerView pickerView, nint row, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BUZZER)
                    return currentViewContorller.buzzerPickerData[(int)row];
               
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Vibrator)
                    return currentViewContorller.vibratorPickerData[(int)row];
                
                return "None";
            }
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }
        //#pragma mark - UIPickerViewDataSource
        private class MyPickerViewDataSource : UIPickerViewDataSource
        {
            BarcodeOption_VC currentViewContorller;
            public MyPickerViewDataSource(BarcodeOption_VC controller)
            {
                currentViewContorller = controller;
            }

            public override nint GetComponentCount(UIPickerView pickerView)
            {
                return 1;
            }

            public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BUZZER)
                    return currentViewContorller.buzzerPickerData.Length;

                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Vibrator)
                    return currentViewContorller.vibratorPickerData.Length;

                return 0;
            }
        }

//#pragma mark - IBAction
        partial void buzzerBtnTapped(NSObject sender)
        {
            pickerView.Tag = PICKER_VIEW_BUZZER;
            pickerView.ReloadAllComponents();
            if (buzzerTextField.Text != "")
            {
                int index = Array.IndexOf(buzzerPickerData, buzzerTextField.Text);
                pickerView.Select((nint)index, 0, false);
            }
            else
                pickerView.Select(0, 0, false);

            buzzerPickerTopView.Hidden = false;
            showPickerView();
        }
        partial void vibratorBtnTapped(NSObject sender)
        {
            pickerView.Tag = PICKER_VIEW_Vibrator;
            pickerView.ReloadAllComponents();
            if (vibratorTextField.Text != "")
            {
                int index = Array.IndexOf(vibratorPickerData, vibratorTextField.Text);
                pickerView.Select((nint)index, 0, false);
            }
            else
                pickerView.Select(0, 0, false);

            vibratorPickerTopView.Hidden = false;
            showPickerView();
        }
        partial void batteryIntervalBtnTapped(NSObject sender)
        {
            UIAlertController alert = UIAlertController.Create("Battery Interval:", "Please enter battery interval.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.NumberPad;
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string value = textField.Text;
                if (value.Length == 0) value = "0";
                setBatteryInterval(value);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void sleepTimeBtnTapped(NSObject sender)
        {
            UIAlertController alert = UIAlertController.Create("Battery Interval:", "Please enter battery interval.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.NumberPad;
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string value = textField.Text;
                if (value.Length == 0) value = "0";
                setSleepTime(value);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void saveBtnTapped(NSObject sender)
        {
            mReader.Buzzer = buzzerValue;
            mReader.Vibrator = vibratorValue;
            mReader.SleepTime = sleepTimeValue;

            systemSetting.setBuzzer((int)buzzerValue);
            systemSetting.setVibrator((int)vibratorValue);
            systemSetting.setSleepTime((int)sleepTimeValue);

            UserData.setBatteryInterval(batteryIntervalValue);
            UIAlertController alert = UIAlertController.Create("Success", "Saved successfully", UIAlertControllerStyle.Alert);
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void defaultBtnTapped(NSObject sender)
        {
            mReader.Buzzer = BuzzerState.High;
            mReader.Vibrator = VibratorState.n;
            mReader.SleepTime = 300;

            buzzerValue = mReader.Buzzer;
            vibratorValue = mReader.Vibrator;
            sleepTimeValue = mReader.SleepTime;

            systemSetting.setBuzzer((int)buzzerValue);
            systemSetting.setVibrator((int)vibratorValue);
            systemSetting.setSleepTime((int)sleepTimeValue);

            UserData.setBatteryInterval("10000");
            initViewData();
            UIAlertController alert = UIAlertController.Create("Success", "Set to default successfully", UIAlertControllerStyle.Alert);
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void pickerCloseBtnTapped(NSObject sender)
        {
            hidePickerView();
        }
        partial void buzzerPickerOkBtnTapped(NSObject sender)
        {
            int idx = (int)pickerView.SelectedRowInComponent(0);
            setBuzzer(idx);
            hidePickerView();
        }
        partial void vibratorPickerOkBtnTapped(NSObject sender)
        {
            int idx = (int)pickerView.SelectedRowInComponent(0);
            setVibrator(idx);
            hidePickerView();
        }
//#pragma mark - Custom
        void showPickerView()
        {
            pickerView.Hidden = false;
            shadowView.Hidden = false;
        }
        void hidePickerView()
        {
            vibratorPickerTopView.Hidden = true;
            buzzerPickerTopView.Hidden = true;
            pickerView.Hidden = true;
            shadowView.Hidden = true;
        }
        void hideTableView()
        {
            shadowView.Hidden = true;
        }
        void setBuzzer(int index)
        {
            buzzerTextField.Text = buzzerPickerData[index];
            buzzerValue = (BuzzerState)index;
        }
        void setVibrator(int index)
        {
            vibratorTextField.Text = vibratorPickerData[index];
            vibratorValue = (VibratorState)index;
        }
        void setBatteryInterval(string batteryInterval)
        {
            batteryIntervalTextField.Text = batteryInterval;
            batteryIntervalValue = batteryInterval;
        }
        void setSleepTime(string sleepTime)
        {
            sleepTimeTextField.Text = sleepTime;
            sleepTimeValue = int.Parse(sleepTime);
        }
        void initViewData()
        {
            setBuzzer((int)buzzerValue);
            setVibrator((int)vibratorValue);
            setSleepTime(sleepTimeValue.ToString());
            string batteryInterval = UserData.getBatteryInterval();
            setBatteryInterval(batteryInterval);
        }
    }
}
