// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;
using System.Collections.Generic;

namespace AsReaderGun251GDemoApp
{
    public partial class EpcMaskEditViewController : UIViewController
    {
        readonly int PICKER_VIEW_OFFSET = 0;
        readonly int PICKER_VIEW_LENGTH = 1;

        public AsSelectMaskEPCParam selectMaskParam;
        List<string> pickerData = new List<string>();

        readonly AppDelegate appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;
        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public EpcMaskEditViewController(IntPtr handle) : base(handle)
        {
        }
        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            pickerView.DataSource = new MyPickerViewDataSource(this);
            pickerView.Delegate = new MyPickerViewDelegate(this);

            for (int i = 0; i < appDelegate.DATA_BIT.Length; i++)
            {
                string offset = appDelegate.DATA_BIT[i];
                pickerData.Add(offset + " bit");
            }

            if (selectMaskParam != null)
            {
                int Offset = Array.IndexOf(appDelegate.DATA_BIT, selectMaskParam.Offset.ToString());
                setOffset(Offset);
                setMask(selectMaskParam.Mask);
                int Length = Array.IndexOf(appDelegate.DATA_BIT, selectMaskParam.Length.ToString());
                setLength(Length);
            }
            else
            {
                selectMaskParam = new AsSelectMaskEPCParam();
                setOffset(1);
                setLength(1);
            }
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }
        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
        }
        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
            gunManager.onAsReaderGUNDisconnected = () =>
            {
                AppDelegate.dismissGlobalHUD();
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };

            gunManager.onAsReaderGUNConnected = () =>
            {
                ViewDidAppear(true);
            };

            gunManager.onAsReaderTriggerKeyEvent = (status) =>
            {
                return false;
            };

            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };

            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };
        }

        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }

//#pragma mark - Navigation
        public override bool ShouldPerformSegue(string segueIdentifier, NSObject sender)
        {
            if (segueIdentifier == "BackToSource")
            {
                int index = pickerData.IndexOf(lengthTextField.Text);
                long maskBit = long.Parse(appDelegate.DATA_BIT[index]);
                if (maskTextField.Text.Length != maskBit / 4)
                {
                    UIAlertController alert = UIAlertController.Create("Error", "Mask length is not valid", UIAlertControllerStyle.Alert);
                    alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
                    PresentViewController(alert, true, null);
                    return false;
                }
            }
            return true;
        }

//#pragma mark - UIPickerViewDelegate
        private class MyPickerViewDelegate : UIPickerViewDelegate
        {
            EpcMaskEditViewController currentViewContorller;
            public MyPickerViewDelegate(EpcMaskEditViewController controller)
            {
                currentViewContorller = controller;
            }

            public override string GetTitle(UIPickerView pickerView, nint row, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_OFFSET)
                    return currentViewContorller.pickerData[(int)row];

                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_LENGTH)
                    return currentViewContorller.pickerData[(int)row];

                return "None";
            }
        }

//#pragma mark - UIPickerViewDataSource
        private class MyPickerViewDataSource : UIPickerViewDataSource
        {
            EpcMaskEditViewController currentViewContorller;
            public MyPickerViewDataSource(EpcMaskEditViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint GetComponentCount(UIPickerView pickerView)
            {
                return 1;
            }

            public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_OFFSET)
                    return currentViewContorller.appDelegate.DATA_BIT.Length;

                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_LENGTH)
                    return currentViewContorller.pickerData.Count;
                
                return 0;
            }
        }

//#pragma mark - UITextFieldDelegate
        private class MyTextFieldDelegate : UITextFieldDelegate
        {
            EpcMaskEditViewController currentViewContorller;
            public MyTextFieldDelegate(EpcMaskEditViewController controller)
            {
                currentViewContorller = controller;
            }

            public override bool ShouldChangeCharacters(UITextField textField, NSRange range, string replacementString)
            {
                if (range.Length == 1) return true;

                string a = "0123456789ABCDEFabcdef";

                if (a.IndexOf(replacementString) > -1)
                {
                    string str = textField.Text + replacementString;
                    textField.Text = str.ToUpper();
                }
                return false;
            }

        }
//#pragma mark - IBAction
        partial void offsetBtnTapped(NSObject sender)
        {
            pickerView.Tag = PICKER_VIEW_OFFSET;
            pickerView.ReloadAllComponents();
            if (offsetTextField.Text != "")
            {
                int index = pickerData.IndexOf(offsetTextField.Text); ;
                pickerView.Select((nint)index, 0, false);
            }
            else
                pickerView.Select(0, 0, false);
            
            pickerView.Hidden = false;
            offsetPickerTopView.Hidden = false;
        }
        partial void maskBtnTapped(NSObject sender)
        {
            UIAlertController alert = UIAlertController.Create("Mask:", "Please enter mask value.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Text = maskTextField.Text;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string value = textField.Text;
                if (value.Length == 0) value = "";
                setMask(value);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, Action =>
            {
                setMask("");
            }));
            PresentViewController(alert, true, null);
        }
        partial void lengthBtnTapped(NSObject sender)
        {
            pickerView.Tag = PICKER_VIEW_LENGTH;
            pickerView.ReloadAllComponents();
            if (lengthTextField.Text != "")
            {
                int index = pickerData.IndexOf(lengthTextField.Text);
                pickerView.Select((nint)index, 0, false);
            }
            else
                pickerView.Select(0, 0, false);
            
            pickerView.Hidden = false;
            lengthPickerTopView.Hidden = false;
        }
        partial void pickerCloseBtnTapped(NSObject sender)
        {
            hidePickerView();
        }
        partial void offsetPickerOkBtnTapped(NSObject sender)
        {
            long idx = pickerView.SelectedRowInComponent(0);
            setOffset((int)idx);
            hidePickerView();
        }
        partial void lengthPickerOkBtnTapped(NSObject sender)
        {
            long idx = pickerView.SelectedRowInComponent(0);
            setLength((int)idx);
            hidePickerView();
        }
//#pragma mark - Custom
        void hidePickerView()
        {
            offsetPickerTopView.Hidden = true;
            lengthPickerTopView.Hidden = true;
            pickerView.Hidden = true;
        }
        void setOffset(int index)
        {
            offsetTextField.Text = pickerData[index];
            selectMaskParam.Offset = int.Parse(appDelegate.DATA_BIT[index]);
        }
        void setMask(string mask)
        {
            maskTextField.Text = mask;
            selectMaskParam.Mask = mask;
        }
        void setLength(int index)
        {
            lengthTextField.Text = pickerData[index];
            selectMaskParam.Length = int.Parse(appDelegate.DATA_BIT[index]);
        }
    }
}
