// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;

namespace AsReaderGun251GDemoApp
{
    public partial class EpcMaskViewController : UIViewController
    {
        readonly AppDelegate appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;
        readonly SystemSetting systemSetting = SystemSetting.sharedSystemSetting();

        bool isEditCell;
        NSMutableArray maskData = new NSMutableArray();

        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public EpcMaskViewController(IntPtr handle) : base(handle)
        {
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            enableActionWidgets(false);
            tableView.DataSource = new MyTableViewSource(this);
            tableView.Delegate = new MyTableViewDelegate(this);

            cancelBtn.TouchUpInside += (object sender, EventArgs e) =>
            {
                NavigationController.PopViewController(true);
            };

            if (mReader == null) return;
            
            AppDelegate.showGlobalProgressHUDWithTitle("Loading...");
            bool matchMode = mReader.EpcMaskMatchMode;
            initLoadMask();
            matchModeSwitch.On = matchMode;
            AppDelegate.dismissGlobalHUD();
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }
        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
        }
        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
            isEditCell = false;
            gunManager.onAsReaderGUNDisconnected = () =>
            {
                AppDelegate.dismissGlobalHUD();
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };

            gunManager.onAsReaderGUNConnected = () =>
            {
                ViewDidAppear(true);
            };

            gunManager.onAsReaderTriggerKeyEvent = (status) =>
            {
                return false;
            };

            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };

            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };
        }
        
        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }

//#pragma mark - Storyboard Segue
        public override void PrepareForSegue(UIStoryboardSegue segue, NSObject sender)
        {
            if (segue.Identifier == "EpcMaskCell")
            {
                EpcMaskEditViewController vc = (EpcMaskEditViewController)segue.DestinationViewController;
                NSIndexPath indexPath = tableView.IndexPathForCell((UITableViewCell)sender);
                vc.selectMaskParam = maskData.GetItem<AsSelectMaskEPCParam>((nuint)indexPath.Row);
                isEditCell = true;
            }
        }

//#pragma mark - Storyboard Segue
        partial void prepareForUnwind(UIStoryboardSegue segue)
        {
            EpcMaskEditViewController sourceViewController = (EpcMaskEditViewController)segue.SourceViewController;
            if (!isEditCell)
            {
                maskData.Add(sourceViewController.selectMaskParam);
            }
            tableView.ReloadData();
        }

        //#pragma mark - UITableViewDelegate
        private class MyTableViewDelegate : UITableViewDelegate
        {
            EpcMaskViewController currentViewContorller;
            public MyTableViewDelegate(EpcMaskViewController controller)
            {
                currentViewContorller = controller;
            }

            public override UITableViewCellEditingStyle EditingStyleForRow(UITableView tableView, NSIndexPath indexPath)
            {
                return UITableViewCellEditingStyle.Delete;
            }
        }

//#pragma mark - UITableViewDataSource
        private class MyTableViewSource : UITableViewDataSource
        {
            EpcMaskViewController currentViewContorller;
            public MyTableViewSource(EpcMaskViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint NumberOfSections(UITableView tableView)
            {
                return 1;
            }

            public override nint RowsInSection(UITableView tableView, nint section)
            {
                if (currentViewContorller.maskData != null) return (nint)currentViewContorller.maskData.Count;
                return 0;
            }

            public override UITableViewCell GetCell(UITableView tableView, NSIndexPath indexPath)
            {
                EpcMaskTableViewCell cell = (EpcMaskTableViewCell)tableView.DequeueReusableCell("EpcMaskCell", indexPath);
                AsSelectMaskEPCParam maskParam = currentViewContorller.maskData.GetItem<AsSelectMaskEPCParam>((nuint)indexPath.Row);
                if (maskParam != null && cell != null)
                {
                    cell.offsetLabel.Text = ((uint)maskParam.Offset).ToString() + "bit";
                    cell.lengthLabel.Text = ((uint)maskParam.Length).ToString() + "bit";
                    cell.maskLabel.Text = maskParam.Mask;
                }

                return cell;
            }

            public override void CommitEditingStyle(UITableView tableView, UITableViewCellEditingStyle editingStyle, NSIndexPath indexPath)
            {
                currentViewContorller.maskData.RemoveObject(indexPath.Row);
                tableView.ReloadData();
            }
        }

//#pragma mark - IBAction
        partial void saveBtnTapped(NSObject sender)
        {
            enableActionWidgets(false);
            AppDelegate.showGlobalProgressHUDWithTitle("Saving...");
            ResultCode code = mReader.ClearEpcMask;
            for (nuint i = 0; i < maskData.Count; i++)
            {
                AsSelectMaskEPCParam param = maskData.GetItem<AsSelectMaskEPCParam>(i);
                mReader.AddEpcMask(param);
            }

            if (matchModeSwitch.On)
            {
                mReader.EpcMaskMatchMode = true;
                systemSetting.setEpcMaskMatchMode(true);
            }
            else
            {
                mReader.EpcMaskMatchMode = false;
                systemSetting.setEpcMaskMatchMode(false);
            }
            systemSetting.setSelectionEpcMaskData(maskData);
            enableActionWidgets(true);
            AppDelegate.dismissGlobalHUD();
            UIAlertController alert = UIAlertController.Create("Error", "Saved successfully", UIAlertControllerStyle.Alert);
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
            PerformSelector(new ObjCRuntime.Selector("pop2"), null, 1);
            
        }
        [Export("pop2")]
        void testPop2()
        {
            NavigationController.PopViewController(true);
        }
        //#pragma mark - Custom
        void initLoadMask()
        {
            for (int i = 0; i < mReader.EpcMaskCount; i++)
            {
                AsSelectMaskEPCParam param = mReader.GetEpcMask(i);
                if (param != null) maskData.Add(param);
            }
            tableView.ReloadData();
            enableActionWidgets(true);
        }
        public void enableActionWidgets(bool enabled)
        {
            nuint count = maskData.Count;
            addBarButtonItem.Enabled = enabled && (int)count < Define.MAX_SELECTION_MASK;
            saveBtn.Enabled = enabled;
            cancelBtn.Enabled = enabled;
        }
    }
}
