// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using UIKit;
using System.Collections.Generic;
using Foundation;

namespace AsReaderGun251GDemoApp
{
	public partial class InventoryViewController : UIViewController
	{
        readonly int             PICKER_VIEW_INVENTORY_SESSION = 0;
        readonly int             PICKER_VIEW_POWER_GAIN = 1;
        readonly int             PICKER_VIEW_SESSION_FLAG = 2;
        readonly List<string>    powerGainPickerData = new List<string>();
        private List<AsTagitem> aryTags = new List<AsTagitem>();
        NSMutableDictionary      mapTags = new NSMutableDictionary();
        UIAlertController        currentAlert;

        bool                     _isReloadNeeded;
        long                     currentTagCount;
        MaskType                 maskType;
        bool                     isCanScan;
        readonly SystemSetting   systemSetting = SystemSetting.sharedSystemSetting();
        readonly AppDelegate     appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;
        SessionType              inventorySession;
        SessionFlag              sessionFlag;

        long                     mTotalTagCount;
        long                     mTotalTagCounts;
        double                   mLastTime;
        double                   mTagSpeed;
        bool                     isfinishedInitial;
        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public InventoryViewController (IntPtr handle) : base (handle)
		{
		}

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
           
            tableView.DataSource = new MyTableViewSource(this);
            tableView.Delegate = new MyTableViewDelegate(this);

            pickerView.DataSource = new MyPickerViewDataSource(this);
            pickerView.Delegate = new MyPickerViewDelegate(this);

            powerGainTextField.Delegate = new MyTextFieldDelegate(this);

            _isReloadNeeded = true;

            int min = mReader.PowerGainRange.min;
            int max = mReader.PowerGainRange.max;
            for (int i = min; i <= max; i += 10)
                powerGainPickerData.Add((i / 10).ToString() + ".0 dB");

            AppDelegate.showGlobalProgressHUDWithTitle("Loading");
        }

        void UpdateUI()
        {
            tagCountLabel.Text = aryTags.Count.ToString();
            totalTagCountLabel.Text = mTotalTagCounts.ToString();
            speedLabel.Text = mTagSpeed.ToString("F2") + " tps";
            tableView.ReloadData();
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }
        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);

            if (mReader != null)
            {
                SetInventorySession(mReader.InventorySession);
                SetSessionFlag(mReader.SessionFlag);
            }

            gunManager.onAsReaderGUNDisconnected = () =>
            {
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };
            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };
            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
                return false;
            };
            gunManager.readTag = (tag, rssi, phase, frequency) =>
            {
                if (reportTidSwitch.On == true)
                {
                    return;
                }
                double time = new NSDate().SecondsSinceReferenceDate;
                double interval = 0.0;

                mTotalTagCount++;
                mTotalTagCounts++;

                if (mLastTime == 0.0)
                {
                    mTagSpeed = 0.0;
                    mLastTime = time;
                }
                else
                {
                    interval = time - mLastTime;
                    if (interval != 0.0)
                    {
                        mTagSpeed = (mTotalTagCount - currentTagCount) / interval;
                    }
                }
                //if (reportRssiSwitch.On == false)
                //{
                //    rssi = 0;
                //    phase = 0;
                //}

                AsTagitem item = null;

                string newData = RainTagHelper.convertUniqueStringDataTag(tag);

                if ((item = (AsTagitem)mapTags.ObjectForKey(new NSString(newData))) != null)
                {
                    item.count++;
                    item.updateRssi(rssi, phase, frequency);
                }
                else
                {
                    item = AsTagitem.itemWith(tag, rssi, phase, frequency, "");
                    aryTags.Add(item);
                    mapTags.SetValueForKey(item, new NSString(newData));
                }

                tagCountLabel.Text = aryTags.Count.ToString();
                totalTagCountLabel.Text = mTotalTagCounts.ToString();
                speedLabel.Text = mTagSpeed.ToString("F2") + " tps";
                tableView.ReloadData();
            };
            gunManager.changedActionState = (action, resultCode) =>
            {
                //Console.WriteLine("Action : " + action);
                if (action == CommandType.Stop)
                {
                    foreach (UIControl control in toDisableElems)
                        control.Enabled = false;
                    reportTidSwitch.Enabled = true;
                    NSThread.SleepFor(0.3);
                    Title = "Inventory";
                    inventoryBtn.SetTitle("Inventory", UIControlState.Normal);
                    mLastTime = 0;
                    currentTagCount = mTotalTagCount;
                    foreach (UIControl control in toDisableElems)
                        control.Enabled = true;
                    tableView.UserInteractionEnabled = true;
                    if (resultCode == (uint)ResultCode.NoError)
                    {
                        isCanScan = true;
                        CancelPreviousPerformRequest(this, new ObjCRuntime.Selector("changStatus"), null);
                    }
                    else
                    {
                        isCanScan = false;
                        CancelPreviousPerformRequest(this, new ObjCRuntime.Selector("changStatus"), null);
                        PerformSelector(new ObjCRuntime.Selector("changStatus"), null, 1.0, null);
                    }
                }
                else
                {
                    if (action == CommandType.Inventory)
                    {
                        foreach (UIControl control in toDisableElems)
                            control.Enabled = true;
                        reportTidSwitch.Enabled = false;
                    }
                    if (resultCode == (uint)ResultCode.NoError)
                    {
                        inventoryBtn.SetTitle("Stop", UIControlState.Normal);
                        foreach (UIControl control in toDisableElems)
                            control.Enabled = false;
                        tableView.UserInteractionEnabled = false;
                    }
                }
            };
            gunManager.onAsReaderTriggerKeyEvent = (status) =>
            {
                if (!isfinishedInitial)
                {
                    Console.WriteLine("Event] ============> isfinishedInitial");
                    return false;
                }
                if (mReader.ScanMode == ScanMode.RFIDScanMode)
                {
                    if (status)
                    {
                        if (isCanScan)
                            if (reportTidSwitch.On == true)
                            {
                                Console.WriteLine("[Event] ===>Inventory  TID START ");
                                mReader.InventoryWithTidOffset(0, systemSetting.getTidLength(), inventorySession, sessionFlag);
                            }
                            else
                            {

                                _ = mReader.Inventory;
                            }
                    }
                    else
                        _ = mReader.Stop;

                    return false;
                }
                return true;
            };
            gunManager.onModuleOverHeated = () =>
            {
                void showAlert()
                {
                    currentAlert = UIAlertController.Create("", "The RFID module is overheating. Please pause reading until it cools off.", UIAlertControllerStyle.Alert);
                    currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                    {
                        currentAlert = null;
                    }));
                    PresentViewController(currentAlert, true, null);
                }
                if (currentAlert != null)
                    currentAlert.DismissViewController(false, () => showAlert());
                else
                    showAlert();

            };
            gunManager.onResetReader = () =>
            {
                void showAlert()
                {
                    currentAlert = UIAlertController.Create("", "Device must be rebooted due to packet loss.", UIAlertControllerStyle.Alert);
                    currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                    {
                        currentAlert = null;
                    }));
                    PresentViewController(currentAlert, true, null);
                }
                if (currentAlert != null)
                    currentAlert.DismissViewController(false, () => showAlert());
                else
                    showAlert();

            };
            gunManager.readTagWithTid = (error, action, epc, data, rssi, phase, frequency) =>
            {
                if (error != ResultCode.NoError)
                {
                    return;
                }
                double time = new NSDate().SecondsSinceReferenceDate;
                double interval = 0.0;

                mTotalTagCount++;
                mTotalTagCounts++;

                if (mLastTime == 0.0)
                {
                    mTagSpeed = 0.0;
                    mLastTime = time;
                }
                else
                {
                    interval = time - mLastTime;
                    if (interval != 0.0)
                    {
                        mTagSpeed = (mTotalTagCount - currentTagCount) / interval;
                    }
                }

                AsTagitem item = (AsTagitem)mapTags.ObjectForKey(new NSString(epc));
                if (item != null)
                {
                    item.count++;
                    item.updateRssi(rssi, phase, frequency);
                }
                else
                {
                    item = AsTagitem.itemWith(epc, rssi, phase, frequency, data);
                    aryTags.Add(item);
                    mapTags.SetValueForKey(item, new NSString(epc));
                }

                tagCountLabel.Text = aryTags.Count.ToString();
                totalTagCountLabel.Text = mTotalTagCounts.ToString();
                speedLabel.Text = mTagSpeed.ToString("F2") + " tps";
                tableView.ReloadData();
            };
            gunManager.readTagWithRFM = (error, action, epc, rssi, phase, frequency, tid, tempCode, calibration, sensorCode) =>
            {
                if (error != ResultCode.NoError)
                {
                    return;
                }
                string tempV = RFMHelper.calculationTemp(tempCode, calibration);
                string sensorCodeV = RFMHelper.calculationSensorCode(sensorCode, tid);
                tid = "Temp Val :" + tempV + " °C - Scode(Moisture)  :" + sensorCodeV + "\n tid:" + tid + " tc:" + tempCode + " cal:" + calibration + " sc:" + sensorCode;

                double time = new NSDate().SecondsSinceReferenceDate;
                double interval = 0.0;

                mTotalTagCount++;
                mTotalTagCounts++;

                if (mLastTime == 0.0)
                {
                    mTagSpeed = 0.0;
                    mLastTime = time;
                }
                else
                {
                    interval = time - mLastTime;
                    if (interval != 0.0)
                    {
                        mTagSpeed = (mTotalTagCount - currentTagCount) / interval;
                    }
                }

                AsTagitem item = (AsTagitem)mapTags.ObjectForKey(new NSString(epc));
                if (item != null)
                {
                    item.count++;
                    item.updateRssi(rssi, phase, frequency, tid);
                }
                else
                {
                    item = AsTagitem.itemWith(epc, rssi, phase, frequency, tid);
                    aryTags.Add(item);
                    mapTags.SetValueForKey(item, new NSString(epc));
                }

                tagCountLabel.Text = aryTags.Count.ToString();
                totalTagCountLabel.Text = mTotalTagCounts.ToString();
                speedLabel.Text = mTagSpeed.ToString("F2") + " tps";
                tableView.ReloadData();
            };
            gunManager.accessResult = (error, action, epc, data, rssi, phase, frequency) =>
            {
            };
        }
        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
            isfinishedInitial = false;
            if (_isReloadNeeded == false){
                isfinishedInitial = true;
                return;
            }

            _isReloadNeeded = true;

            mTotalTagCount = 0;
            mTotalTagCounts = 0;

            foreach (AsTagitem item in aryTags)
                mTotalTagCounts += item.count;

            mTagSpeed = 0.0;

            currentTagCount = 0;

            speedLabel.Text = "0 tps";
            reportRssiSwitch.On = false;
            isCanScan = true;

            maskType = (MaskType)mReader.MaskTypeValue;
            mReader.StoredMode = false;
            mReader.ReportMode = false;

            int nPower = mReader.PowerGain;
            int operationTime = mReader.OperationTime;

            mLastTime = 0;
            SetPowerGain(nPower / 10);

            mReader.ContinuousMode = systemSetting.getContinuousMode();
            continuousModeSwitch.On = mReader.ContinuousMode;
            mReader.RssiMode = systemSetting.getRssiMode();
            reportRssiSwitch.On = mReader.RssiMode;
            displayPcSwitch.On = systemSetting.getDisPlayPC();
            SetOperationTime(operationTime.ToString());
            SetInventorySession(mReader.InventorySession);
            SetSessionFlag(mReader.SessionFlag);
            tidLabel.Text = "Report TID : (len:" + systemSetting.getTidLength().ToString() + " word)";
            reportTidSwitch.On = systemSetting.getTidOn();
            pickerView.ReloadAllComponents();
            UpdateUI();
            isfinishedInitial = true;
            AppDelegate.dismissGlobalHUD();
        }

        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();
            if (mReader != null)
            {
                _ = mReader.StopSync;
                EnableControlByActionState();
            }
        }
        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }
//#pragma mark - Navigation
        public override void PrepareForSegue(UIStoryboardSegue segue, NSObject sender)
        {
            _isReloadNeeded = true;
            if (segue.Identifier == "ReadMemory")
            {
                ReadMemoryViewController destinationController = (ReadMemoryViewController)segue.DestinationViewController;
                NSIndexPath indexPath = (NSIndexPath)sender;
                destinationController.maskValue = aryTags[indexPath.Row].tag;
            }
            else if (segue.Identifier == "WriteMemory")
            {
                WriteMemoryViewController destinationController = (WriteMemoryViewController)segue.DestinationViewController;
                NSIndexPath indexPath = (NSIndexPath)sender;
                destinationController.maskValue = aryTags[indexPath.Row].tag;
            }
            else if (segue.Identifier == "LockMemory")
            {
                TagAccessViewController destinationController = (TagAccessViewController)segue.DestinationViewController;
                NSIndexPath indexPath = (NSIndexPath)sender;
                destinationController.maskValue = aryTags[indexPath.Row].tag;
            }
        }

//#pragma mark - Storyboard Segue
        public override void PrepareForInterfaceBuilder()
        {

        }

        //#pragma mark - UITableViewDelegate
        class MyTableViewDelegate : UITableViewDelegate
        {
            readonly InventoryViewController currentViewContorller;
            public MyTableViewDelegate(InventoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override void RowSelected(UITableView tableView, NSIndexPath indexPath)
            {
                if (currentViewContorller.mReader.Action != CommandType.Stop) return;

                UIAlertController alert = UIAlertController.Create("Additional Actions", "You can choose one of the following actions for this Tag", UIAlertControllerStyle.Alert);
                alert.AddAction(UIAlertAction.Create("Read Memory", UIAlertActionStyle.Default, Action =>
                {
                    currentViewContorller.PerformSegue("ReadMemory", indexPath);
                }));

                alert.AddAction(UIAlertAction.Create("Write Memory", UIAlertActionStyle.Default, Action =>
                {
                    currentViewContorller.PerformSegue("WriteMemory", indexPath);
                }));

                alert.AddAction(UIAlertAction.Create("Lock Memory", UIAlertActionStyle.Default, Action =>
                {
                    currentViewContorller.PerformSegue("LockMemory", indexPath);
                }));

                alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));

                currentViewContorller.PresentViewController(alert, true, null);
            }
        }

        class MyTableViewSource : UITableViewDataSource
        {
            readonly InventoryViewController currentViewContorller;
            public MyTableViewSource(InventoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint NumberOfSections(UITableView tableView)
            {
                return 1;
            }

            public override nint RowsInSection(UITableView tableView, nint section)
            {
                if (currentViewContorller.aryTags != null) return (nint)currentViewContorller.aryTags.Count;
                return 0;
            }

            public override UITableViewCell GetCell(UITableView tableView, NSIndexPath indexPath)
            {
                InventoryTableViewCell cell = (InventoryTableViewCell)tableView.DequeueReusableCell("InventoryCell", indexPath);
                AsTagitem item = currentViewContorller.aryTags[indexPath.Row];
                if (item != null)
                {
                    if (currentViewContorller.displayPcSwitch.On)
                    {
                        cell.tagLabel.Text = RainTagHelper.getPCStringData(item.tag);
                        cell.epcLabel.Text = RainTagHelper.getEPCStringData(item.tag);
                    } else
                    {
                        cell.tagLabel.Text = RainTagHelper.getEPCStringData(item.tag);
                        cell.epcLabel.Text = "";
                    }
                    cell.countLabel.Text = item.count.ToString();
                    cell.tidLabel.Text = item.tid;
                    if (currentViewContorller.reportRssiSwitch.On)
                    {
                        cell.rssiLabel.Text = Math.Round(item.rssi, 1).ToString() + "dB";
                        cell.phaseLabel.Text = ((int)item.phase).ToString() + "˚";
                        cell.frequency.Text = Math.Round(item.frequency, 2) + "MHz";
                    }
                    else
                    {
                        cell.rssiLabel.Text = "";
                        cell.phaseLabel.Text = "";
                        cell.frequency.Text = "";
                    }
                }
                return cell;
            }
        }

        class MyPickerViewDataSource : UIPickerViewDataSource
        {
            readonly InventoryViewController currentViewContorller;
            public MyPickerViewDataSource(InventoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint GetComponentCount(UIPickerView pickerView)
            {
                return 1;
            }

            public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData.Count;

                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_INVENTORY_SESSION)
                    return (nint)currentViewContorller.InventorySessionPickerData().Count;

                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_SESSION_FLAG)
                    return (nint)currentViewContorller.SessionFlagPickerData().Count;

                return 0;
            }
        }

        private class MyPickerViewDelegate : UIPickerViewDelegate
        {
            readonly InventoryViewController currentViewContorller;
            public MyPickerViewDelegate(InventoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override string GetTitle(UIPickerView pickerView, nint row, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData[(int)row];

                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_INVENTORY_SESSION)
                    return currentViewContorller.InventorySessionPickerData().GetItem<NSString>((uint)row).ToString();

                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_SESSION_FLAG)
                    return currentViewContorller.SessionFlagPickerData().GetItem<NSString>((uint)row).ToString();

                return "None";
            }
        }
//#pragma mark - UITextViewDelegate
        class MyTextFieldDelegate : UITextFieldDelegate
        {
            InventoryViewController currentViewContorller;
            public MyTextFieldDelegate(InventoryViewController controller)
            {
                currentViewContorller = controller;
            }
            public override bool ShouldBeginEditing(UITextField textField)
            {
                return false;
            }
        }
//#pragma mark - IBActions
        partial void PowerGainBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_POWER_GAIN;
            pickerView.ReloadAllComponents();
            if (powerGainTextField.Text != "")
            {
                NSString str = new NSString(powerGainTextField.Text);
                pickerView.Select(powerGainPickerData.IndexOf(str), 0, false);
            }
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            powerGainPickerTopView.Hidden = false;
        }
        partial void DisplayPcSwitchTapped(NSObject _)
        {
            systemSetting.setDisPlayPC(displayPcSwitch.On);
            tableView.ReloadData();
        }
        partial void ContinuousModeSwitchTapped(NSObject _)
        {
            mReader.ContinuousMode = continuousModeSwitch.On;
            systemSetting.setContinuousMode(continuousModeSwitch.On);
        }
        partial void displayTidSwitchTapped(NSObject _)
        {
            systemSetting.setTidOn(reportTidSwitch.On);
            if (reportTidSwitch.On == true)
            {
                UIAlertController alert = UIAlertController.Create("TID Length:", "Please enter TID length(word).\n(ex:1 word = 2byte )", UIAlertControllerStyle.Alert);
                alert.AddTextField(textField =>
                {
                    textField.KeyboardType = UIKeyboardType.NumberPad;
                });
                alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
                {
                    int len = 1;
                    UITextField textField = alert.TextFields[0];
                    string value = textField.Text;
                    if(value.Length == 0){
                        value = @"0";
                     }
                    if (int.Parse(value) < 1)
                    {
                        len = 1;
                    } else {
                        len = int.Parse(value);
                    }
                    systemSetting.setTidLength(len);
                    tidLabel.Text = "Report TID : (len : " + len.ToString() + " word)";
                }));
                alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
                PresentViewController(alert, true, null);
            }

        }
        partial void ReportRssiSwitchTapped(NSObject _)
        {
            mReader.RssiMode = reportRssiSwitch.On;
            systemSetting.setRssiMode(reportRssiSwitch.On);
            //aryTags.RemoveRange(0, aryTags.Count);
            //mapTags = new NSMutableDictionary();

            //currentTagCount = 0;
            //tagCountLabel.Text = "0";
            //totalTagCountLabel.Text = "0";
            //speedLabel.Text = "0 tps";
            //mTagSpeed = 0.0;
            //mLastTime = 0;
            //mTotalTagCount = 0;
            //mTotalTagCounts = 0;
            tableView.ReloadData();
        }
        partial void rfmSensorBtnTap(NSObject sender)
        {
            Title = "RFM Sensor (Beta)";
            _ = mReader.ReadRFMSensorTag;
        }
        partial void InventoryBtnTapped(NSObject sender)
        {
            Console.WriteLine("inventoryBtnTapped : " + mReader.Action);
            if (mReader.Action == CommandType.Stop)
                if (reportTidSwitch.On == true) {
                    NSThread.SleepFor(0.5);
                    mReader.InventoryWithTidOffset(0, systemSetting.getTidLength(),inventorySession,sessionFlag);
                } else {
                    NSThread.SleepFor(0.5);
                    _ = mReader.Inventory;
                }
            else
                _ = mReader.Stop;
        }

        partial void ClearBtnTapped(NSObject _)
        {
            aryTags.RemoveRange(0, aryTags.Count);
            mapTags = new NSMutableDictionary();
            tagCountLabel.Text = "0";
            totalTagCountLabel.Text = "0";
            speedLabel.Text = "0 tps";
            mTagSpeed = 0.0;
            mLastTime = 0;
            mTotalTagCount = 0;
            currentTagCount = 0;
            mTotalTagCounts = 0;

            tableView.ReloadData();
        }
        partial void MaskBtnTapped(NSObject _)
        {
            if (maskType == MaskType.NoMask)
            {
                UIAlertController alert = UIAlertController.Create("", "Please set the mask type in RFID Options menu before using mask.", UIAlertControllerStyle.Alert);
                alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, null));
                PresentViewController(alert, true, null);
                return;
            }
            else if (maskType == MaskType.Selection)
                PerformSegue(@"SelectionMask", this);

            else if (maskType == MaskType.Epc)
                PerformSegue("EpcMask", this);

            _isReloadNeeded = false;
        }
        partial void PickerCloseBtnTapped(NSObject _)
        {
            HidePickerView();
        }
        partial void PowerGainPickerOkBtnTapped(NSObject _)
        {
            if (pickerView.Tag == PICKER_VIEW_POWER_GAIN)
            {
                int idx = (int)pickerView.SelectedRowInComponent(0);
                idx += mReader.PowerGainRange.min / 10;
                SetPowerGain(idx);
                mReader.PowerGain = idx * 10;
                systemSetting.setPowerGain(idx * 10);
            }
            else if (pickerView.Tag == PICKER_VIEW_INVENTORY_SESSION)
            {
                SetInventorySession((SessionType)(uint)pickerView.SelectedRowInComponent(0));
                mReader.InventorySession = inventorySession;
                systemSetting.setInventorySession((int)inventorySession);
            }
            else if (pickerView.Tag == PICKER_VIEW_SESSION_FLAG)
            {
                SetSessionFlag((SessionFlag)(uint)pickerView.SelectedRowInComponent(0));
                mReader.SessionFlag = sessionFlag;
                systemSetting.setSessionFlag(sessionFlag);
            }
            HidePickerView();
        }
        partial void OperationTimeBtnTapped(NSObject _)
        {
            UIAlertController alert = UIAlertController.Create("Operation Time:", "Please enter operation time.\n(ex: 30 ms)", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.NumberPad;
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;
                if (str == "") str = "0";
                int operationTime = int.Parse(str);
                SetOperationTime(str);
                mReader.OperationTime = operationTime;
                systemSetting.setOperationTime(operationTime);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void BackBtnTapped(NSObject _)
        {
            NavigationController.PopViewController(true);
        }
        partial void OnClickOptionButton(NSObject _)
        {
            if (scrollView.Hidden){
                scrollView.Hidden = false;
            }
            else
            {
                scrollView.Hidden = true;
            }
        }

        partial void OnClickInventorySessionButton(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_INVENTORY_SESSION;
            pickerView.ReloadAllComponents();
            pickerView.Select((int)inventorySession, 0, false);
            pickerView.Hidden = false;
            powerGainPickerTopView.Hidden = false;
        }
        partial void OnClickSessionFlagButton(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_SESSION_FLAG;
            pickerView.ReloadAllComponents();
            pickerView.Select((int)sessionFlag, 0, false);
            pickerView.Hidden = false;
            powerGainPickerTopView.Hidden = false;
        }
//#pragma mark - Getters
        NSArray InventorySessionPickerData()
        {
            return NSArray.FromStrings(appDelegate.DATA_INVENTORY_SESSION);
        }
        NSArray SessionFlagPickerData()
        {
            return NSArray.FromStrings(appDelegate.DATA_SESSION_FLAG);
        }
//#pragma mark - Custom
        void HidePickerView()
        {
            powerGainPickerTopView.Hidden = true;
            pickerView.Hidden = true;
        }
        void SetInventorySession(SessionType _inventorySession)
        {
            NSArray data = InventorySessionPickerData();
            NSString str = data.GetItem<NSString>((uint)_inventorySession);
            inventorySessionTextField.Text = str.ToString();
            inventorySession = _inventorySession;
        }
        void SetPowerGain(long power)
        {
            NSString value = new NSString(power + ".0 dB");
            int idx = powerGainPickerData.IndexOf(value);
            if (powerGainPickerData.Count > idx)
                powerGainTextField.Text = powerGainPickerData[idx];
        }
        void SetSessionFlag(SessionFlag _sessionFlag)
        {
            NSArray data = SessionFlagPickerData();
            NSString str = data.GetItem<NSString>((uint)_sessionFlag);
            sessionFlagTextField.Text = str.ToString();
            sessionFlag = _sessionFlag;
        }
        void EnableControlByActionState()
        {
            if (mReader.Action == CommandType.Stop)
            {
                inventoryBtn.SetTitle("Inventory", UIControlState.Normal);
                mLastTime = 0;
                currentTagCount = mTotalTagCount;
                foreach (UIControl control in toDisableElems)
                    control.Enabled = true;

                tableView.UserInteractionEnabled = true;
            }
        }
        void SetOperationTime(string operationTime)
        {
            operationTimeTextField.Text = operationTime;
        }

        [Export("changStatus")]
        void changStatus()
        {
            isCanScan = true;
        }
    }

}
