// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;
using System.Collections.Generic;
using CoreGraphics;

namespace AsReaderGun251GDemoApp
{
	public partial class OptionsViewController : UIViewController
	{
		readonly int PICKER_VIEW_BUZZER = 0;
		readonly int PICKER_VIEW_KEY_ACTION = 1;
		readonly int PICKER_VIEW_MASK_TYPE = 2;
		readonly int PICKER_VIEW_Vibrator = 3;
		readonly int PICKER_VIEW_QValue = 4;
		readonly int PICKER_VIEW_Algorithm = 5;
		readonly int PICKER_VIEW_MaxQValue = 6;
		readonly int PICKER_VIEW_MinQValue = 7;
		readonly int PICKER_VIEW_Link_Profile = 8;
		readonly int PICKER_VIEW_HST_RFTC_FWDPWRTHRSH = 10;

		readonly AppDelegate appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;
		private AsReader mReader
		{
			get => gunManager.GetCurrentAsReader();
		}

		readonly string[] buzzerPickerData = { "Off", "Low", "High" };
		readonly string[] vibratorPickerData = { "Off", "On" };
		readonly string[] keyActionPickerData = { "Not Used", "Used" };
		readonly string[] maskTypePickerData = { "No Mask", "Selection Mask", "EPC Mask" };
		readonly string[] qValuePickerData = { "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15" };
		readonly string[] linkProfilePickerData = { "0", "1", "2", "3" };
		readonly string[] algorithmPickerData = { "Fixed Q", "Dynamic Q" };

		List<NSObject> lbtItemData;
		BuzzerState buzzerValue;
		VibratorState vibratorValue;
		int inventoryTimeValue;
		int idleTimeValue;
		int autoOffTimeValue;
		int keyActionValue;

		string batteryIntervalValue;
		MaskType maskTypeValue;
		AlgorithmType algorithmValue;

		int qValue;
		int minQValue;
		int maxQValue;

		int linkProfileValue;
		int defaultLinkProfileValue;
		int sleepTimeValue;
		int thresHoldValue;

		bool isJapan;

		readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
		readonly SystemSetting systemSetting = SystemSetting.sharedSystemSetting();

		public OptionsViewController (IntPtr handle) : base (handle)
		{
		}

		public override void ViewDidLoad()
		{
			base.ViewDidLoad();
			isJapan = false;

			tableView.DataSource = new MyTableViewSource(this);
			tableView.Delegate = new MyTableViewDelegate(this);

			pickerView.DataSource = new MyPickerViewDataSource(this);
			pickerView.Delegate = new MyPickerViewDelegate(this);

			scrollView.ContentSize = new CGSize(0, 1000);
			scrollView.ShowsVerticalScrollIndicator = false;
		}
		[Export("pop")]
		void testPop()
		{
			NavigationController.PopToRootViewController(true);
		}
		public override void ViewWillAppear(bool animated)
		{
			base.ViewWillAppear(animated);
			gunManager.onAsReaderGUNDisconnected = () =>
            {
				AppDelegate.dismissGlobalHUD();
				PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
			};

			gunManager.onAsReaderTriggerKeyEvent = (status) =>
			{
				return false;
			};

			gunManager.onAsReaderLeftModeKeyEvent = (status) =>
			{
				if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
				return false;
			};
			gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
				if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;
				return false;
			};
			
			gunManager.updateDeviceState = (error) =>
            {
				if (error != ResultCode.NoError)
				{
                    UIAlertController alert = UIAlertController.Create("Error", "Failed to get response. Try again.", UIAlertControllerStyle.Alert);
                    alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
                    PresentViewController(alert, true, null);
					PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
				}
			};
		}

		public override void ViewDidAppear(bool animated)
		{
			if (mReader == null) return;
			AppDelegate.showGlobalProgressHUDWithTitle("Loading...");

			vibratorValue = mReader.Vibrator;
			buzzerValue = mReader.Buzzer;
			inventoryTimeValue = mReader.InventoryTime;
			idleTimeValue = mReader.IdleTime;
			autoOffTimeValue = mReader.AutoOffTime;
			qValue = mReader.QValue;
			maxQValue = mReader.MaxQ;
			minQValue = mReader.MinQ;
			algorithmValue = mReader.Algorithm;
			linkProfileValue = mReader.LinkProfileValue;
			defaultLinkProfileValue = mReader.DefaultLinkProfileValue;
			maskTypeValue = (MaskType)mReader.MaskTypeValue;
			sleepTimeValue = mReader.SleepTime;
			thresHoldValue = mReader.ThresHoldValue;
			isJapan = mReader.RegionName.StartsWith("Japan", StringComparison.CurrentCulture);
			if (isJapan)
			{
				setLBTButton.Hidden = false;
				initLbtItemData();
			}
			else
                setLBTButton.Hidden = true;
			initViewData();
			tableView.ReloadData();
			NavigationController.View.AddSubview(shadowView);
			AppDelegate.dismissGlobalHUD();
		}

		public override void ViewWillDisappear(bool animated)
		{
			base.ViewWillDisappear(animated);
			gunManager.ResetDelegate();
		}
		public override void DidReceiveMemoryWarning()
		{
			base.DidReceiveMemoryWarning();
		}

//#pragma mark - UITableViewDataSource
		class MyTableViewSource : UITableViewDataSource
		{
			OptionsViewController currentViewContorller;
			public MyTableViewSource(OptionsViewController controller)
			{
				currentViewContorller = controller;
			}

			public override nint NumberOfSections(UITableView tableView)
			{
				return 1;
			}

			public override nint RowsInSection(UITableView tableView, nint section)
			{
				if (currentViewContorller.lbtItemData != null) return currentViewContorller.lbtItemData.Count;
				return 0;
			}

			public override UITableViewCell GetCell(UITableView tableView, NSIndexPath indexPath)
			{
				UITableViewCell cell = tableView.DequeueReusableCell("LbtCell", indexPath);
				LbtItem lbtItem = (LbtItem)currentViewContorller.lbtItemData[indexPath.Row];
				if (lbtItem.MIsUsed) cell.Accessory = UITableViewCellAccessory.Checkmark;
				else cell.Accessory = UITableViewCellAccessory.None;
				cell.TextLabel.Text = lbtItem.Frequency;
				return cell;
			}

		}

//#pragma mark - UITableViewDelegate
		class MyTableViewDelegate : UITableViewDelegate
		{
			OptionsViewController currentViewContorller;
			public MyTableViewDelegate(OptionsViewController controller)
			{
				currentViewContorller = controller;
			}

			public override void RowSelected(UITableView tableView, NSIndexPath indexPath)
			{
				UITableViewCell cell = tableView.CellAt(indexPath);
				LbtItem lbtItem = (LbtItem)currentViewContorller.lbtItemData[indexPath.Row];
				if (cell.Accessory == UITableViewCellAccessory.Checkmark)
				{
					cell.Accessory = UITableViewCellAccessory.None;
					lbtItem.MIsUsed = false;
				}
				else
				{
					cell.Accessory = UITableViewCellAccessory.Checkmark;
					lbtItem.MIsUsed = true;
				}
			}
			public override void RowDeselected(UITableView tableView, NSIndexPath indexPath)
			{
				UITableViewCell cell = tableView.CellAt(indexPath);
				LbtItem lbtItem = (LbtItem)currentViewContorller.lbtItemData[indexPath.Row];
				if (cell.Accessory == UITableViewCellAccessory.Checkmark)
				{
					cell.Accessory = UITableViewCellAccessory.None;
					lbtItem.MIsUsed = false;
				}
				else
				{
					cell.Accessory = UITableViewCellAccessory.Checkmark;
					lbtItem.MIsUsed = true;
				}
			}
		}

//#pragma mark - UIPickerViewDataSource
		class MyPickerViewDataSource : UIPickerViewDataSource
		{
			OptionsViewController currentViewContorller;
			public MyPickerViewDataSource(OptionsViewController controller)
			{
				currentViewContorller = controller;
			}

			public override nint GetComponentCount(UIPickerView pickerView)
			{
				return 1;
			}

			public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
			{
				//throw new NotImplementedException();
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BUZZER)
                    return currentViewContorller.buzzerPickerData.Length;

				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_KEY_ACTION)
                    return currentViewContorller.keyActionPickerData.Length;

				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_MASK_TYPE)
					return currentViewContorller.maskTypePickerData.Length;
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Vibrator)
					return currentViewContorller.vibratorPickerData.Length;
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_QValue)
					return currentViewContorller.qValuePickerData.Length;
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Algorithm)
					return currentViewContorller.algorithmPickerData.Length;
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_MinQValue)
					return currentViewContorller.qValuePickerData.Length;
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_MaxQValue)
					return currentViewContorller.qValuePickerData.Length;
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Link_Profile)
					return currentViewContorller.linkProfilePickerData.Length;
				
				return 0;
			}
		}

//#pragma mark - UIPickerViewDelegate
		private class MyPickerViewDelegate : UIPickerViewDelegate
		{
			OptionsViewController currentViewContorller;
			public MyPickerViewDelegate(OptionsViewController controller)
			{
				currentViewContorller = controller;
			}

			public override string GetTitle(UIPickerView pickerView, nint row, nint component)
			{
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BUZZER)
					return currentViewContorller.buzzerPickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_KEY_ACTION)
					return currentViewContorller.keyActionPickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_MASK_TYPE)
					return currentViewContorller.maskTypePickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Vibrator)
					return currentViewContorller.vibratorPickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_QValue)
					return currentViewContorller.qValuePickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Algorithm)
					return currentViewContorller.algorithmPickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_MinQValue)
					return currentViewContorller.qValuePickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_MaxQValue)
					return currentViewContorller.qValuePickerData[row];
				
				if (pickerView.Tag == currentViewContorller.PICKER_VIEW_Link_Profile)
					return currentViewContorller.linkProfilePickerData[row];
				
				return "None";
			}
		}


//#pragma mark - Init
		void initLbtItemData()
		{
			if (lbtItemData == null)
			{
				List<NSObject> lbtItems = new List<NSObject>(mReader.LBT);
				LbtItem lbtI = new LbtItem();
				foreach (LbtItem lbtItem in lbtItems)
				{
					lbtItem.Frequency = mReader.GetLBTFrequency(lbtItem.MSlot);
					if (lbtItem.Frequency == "0 HZ") lbtI = lbtItem;
				}
				lbtItems.Remove(lbtI);
				lbtItemData = lbtItems;
			}
		}

//#pragma mark - IBAction
		partial void minQValueBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_MinQValue;
			pickerView.ReloadAllComponents();
			if (minQValueTextField.Text != "")
			{
				int index = Array.IndexOf(qValuePickerData, minQValueTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
                pickerView.Select(0, 0, false);
			qValuePickerTopView.Hidden = false;
			showPickerView();
		}
        partial void adminBtnAction(NSObject sender)
        {
			UIAlertController alert = UIAlertController.Create("Enter your Password", "", UIAlertControllerStyle.Alert);
			alert.AddTextField(textField =>
			{
                textField.Placeholder = "Current Password";
                textField.SecureTextEntry = true;
            });
			alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
			{
				UITextField textField = alert.TextFields[0];
				string value = textField.Text;
				if (value != "111111")
				{
					UIAlertController alertVC = UIAlertController.Create("Please check your password and try again", "", UIAlertControllerStyle.Alert);
					alertVC.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
					PresentViewController(alertVC, true, null);
				} else {
					UIViewController controller = (UIViewController)Storyboard.InstantiateViewController("RegionSettingViewController");
					NavigationController.PushViewController(controller, true);
				}
			}));
			alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
			PresentViewController(alert, true, null);
		}

        partial void maxQValueBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_MaxQValue;
			pickerView.ReloadAllComponents();
			if (maxQValueTextField.Text != "")
			{
				int index = Array.IndexOf(qValuePickerData, maxQValueTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
                pickerView.Select(0, 0, false);
			qValuePickerTopView.Hidden = false;
			showPickerView();
		}
		partial void qValueBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_QValue;
			pickerView.ReloadAllComponents();
			if (qValueTextField.Text != "")
			{
				int index = Array.IndexOf(qValuePickerData, qValueTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
                pickerView.Select(0, 0, false);

			qValuePickerTopView.Hidden = false;
			showPickerView();
		}
		partial void algorithmBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_Algorithm;
			pickerView.ReloadAllComponents();
			if (algorithmTextField.Text != "")
			{
				int index = Array.IndexOf(algorithmPickerData, algorithmTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
                pickerView.Select(0, 0, false);
			
			algorithmPickerTopView.Hidden = false;
			showPickerView();
		}
		partial void linkProfileBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_Link_Profile;
			pickerView.ReloadAllComponents();
			if (linkProfileTextField.Text != "")
			{
				int index = Array.IndexOf(linkProfilePickerData, linkProfileTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
				pickerView.Select(0, 0, false);
			
			LinkProfileTableTopView.Hidden = false;
			showPickerView();
		}

        partial void fwdPWRTHRSHBtnTapped(NSObject sender)
        {
			// //#issue 4-2 (Default Link Profile : L251G Not use this function)
			if (mReader.IsAvailableDefaultLinkProfile)
			{
                UIAlertController noticeAlert = UIAlertController.Create("Notice !!", "This model does not support the [HST_RFTC_FWDPWRTHRSH] function.", UIAlertControllerStyle.Alert);
				noticeAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
                PresentViewController(noticeAlert, true, null);
                return;
			}

            UIAlertController alert = UIAlertController.Create("Please enter ThresholdValue", "Default : 50 (MIN = 50 / MAX = 70)", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.NumberPad;
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string value = textField.Text;
				if (value.Length == 0)
				{
					value = "50";
					UIAlertController alertVC = UIAlertController.Create("Please enter appropriate ThresholdValue", "Thres Hold' should be greater than or equal 50  and less than or equal 70.", UIAlertControllerStyle.Alert);
					alertVC.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
					PresentViewController(alertVC, true, null);
				}
				
				if (int.Parse(value) < 50)
				{
					value = "50";
					UIAlertController alertVC = UIAlertController.Create("Please enter appropriate ThresholdValue", "Thres Hold' should be greater than or equal 50.", UIAlertControllerStyle.Alert);
					alertVC.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
					PresentViewController(alertVC, true, null);
				}
			    if (int.Parse(value) > 70)
				{
					value = "70";
					UIAlertController alertVC = UIAlertController.Create("Please enter appropriate ThresholdValue", "Thres Hold' should be less than or equal 70.", UIAlertControllerStyle.Alert);
					alertVC.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
					PresentViewController(alertVC, true, null);
				}
				setThresHold(value);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }

		partial void buzzerBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_BUZZER;
			pickerView.ReloadAllComponents();
			if (buzzerTextField.Text != "")
			{
				int index = Array.IndexOf(buzzerPickerData, buzzerTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
                pickerView.Select(0, 0, false);

			buzzerPickerTopView.Hidden = false;
			showPickerView();
		}
		partial void vibratorBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_Vibrator;
			pickerView.ReloadAllComponents();
			if (vibratorTextField.Text != "")
			{
				int index = Array.IndexOf(vibratorPickerData, vibratorTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
                pickerView.Select(0, 0, false);

			vibratorPickerTopView.Hidden = false;
			showPickerView();
		}
		partial void inventoryTimeBtnTapped(NSObject sender)
		{
			UIAlertController alert = UIAlertController.Create("Inventory Time:", "Please enter inventory time.", UIAlertControllerStyle.Alert);
			alert.AddTextField(textField =>
			{
				textField.KeyboardType = UIKeyboardType.NumberPad;
			});
			alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
			{
				UITextField textField = alert.TextFields[0];
				string value = textField.Text;
				if (value.Length == 0) value = "0";
				setInventoryTime(value);
			}));
			alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
			PresentViewController(alert, true, null);
		}
		partial void idleTimeBtnTapped(NSObject sender)
		{
			UIAlertController alert = UIAlertController.Create("Idle Time:", "Please enter idle time.", UIAlertControllerStyle.Alert);
			alert.AddTextField(textField =>
			{
				textField.KeyboardType = UIKeyboardType.NumberPad;
			});
			alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
			{
				UITextField textField = alert.TextFields[0];
				string value = textField.Text;
				if (value.Length == 0) value = "0";
				setIdleTime(value);
			}));
			alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
			PresentViewController(alert, true, null);
		}
		partial void autoOffTimeBtnTapped(NSObject sender)
		{
			UIAlertController alert = UIAlertController.Create("Auto Off Time:", "Please enter auto off time.", UIAlertControllerStyle.Alert);
			alert.AddTextField(textField =>
			{
				textField.KeyboardType = UIKeyboardType.NumberPad;
			});
			alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
			{
				UITextField textField = alert.TextFields[0];
				string value = textField.Text;
				if (value.Length == 0) value = "0";
				setAutoOffTime(value);
			}));
			alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
			PresentViewController(alert, true, null);
		}
		partial void batteryIntervalBtnTapped(NSObject sender)
		{
			UIAlertController alert = UIAlertController.Create("Battery Interval:", "Please enter battery interval.", UIAlertControllerStyle.Alert);
			alert.AddTextField(textField =>
			{
				textField.KeyboardType = UIKeyboardType.NumberPad;
			});
			alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
			{
				UITextField textField = alert.TextFields[0];
				string value = textField.Text;
				if (value.Length == 0) value = "0";
				int checkTime = Convert.ToInt32(value);
				if ((value.Length == 0) | (checkTime < 10000))
				{
                    value = @"10000";
                }
				setBatteryInterval(value);
			}));
			alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
			PresentViewController(alert, true, null);
		}
		partial void maskTypeBtnTapped(NSObject sender)
		{
			pickerView.Tag = PICKER_VIEW_MASK_TYPE;
			pickerView.ReloadAllComponents();
			if (maskTypeTextField.Text != "")
			{
				int index = Array.IndexOf(maskTypePickerData, maskTypeTextField.Text);
				pickerView.Select((nint)index, 0, false);
			}
			else
                pickerView.Select(0, 0, false);

			maskTypePickerTopView.Hidden = false;
			showPickerView();
		}
		
		
		partial void sleepTimeBtnTapped(NSObject sender)
		{
			UIAlertController alert = UIAlertController.Create("sleep Time:", "Please enter sleep time.", UIAlertControllerStyle.Alert);
			alert.AddTextField(textField =>
			{
				textField.KeyboardType = UIKeyboardType.NumberPad;
			});
			alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
			{
				UITextField textField = alert.TextFields[0];
				string value = textField.Text;
				if (value.Length == 0) value = "0";
				setSleepTime(value);
			}));
			alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
			PresentViewController(alert, true, null);
		}
		partial void saveBtnTapped(NSObject sender)
		{
			AppDelegate.showGlobalProgressHUDWithTitle("Saving...");
			mReader.Buzzer = buzzerValue;
			mReader.Vibrator = vibratorValue;
			mReader.InventoryTime = inventoryTimeValue;
			mReader.IdleTime = idleTimeValue;
			mReader.AutoOffTime = autoOffTimeValue;
			mReader.QValue = qValue;
			mReader.Algorithm = algorithmValue;
			mReader.MaxQ = maxQValue;
			mReader.MinQ = minQValue;
			mReader.SleepTime = sleepTimeValue;
			mReader.MaskTypeValue = (int)maskTypeValue;
			mReader.ThresHoldValue = thresHoldValue;
			UserData.setBatteryInterval(batteryIntervalValue);

			systemSetting.setBuzzer((int)buzzerValue);
			systemSetting.setVibrator((int)vibratorValue);
			systemSetting.setInventoryTime((int)inventoryTimeValue);
			systemSetting.setIdleTime((int)idleTimeValue);
			systemSetting.setAutoOffTime((int)autoOffTimeValue);
			systemSetting.setQValue((int)qValue);
			systemSetting.setAlgorithm((int)algorithmValue);
			systemSetting.setMaxQ((int)maxQValue);
			systemSetting.setMinQ((int)minQValue);
			systemSetting.setSleepTime((int)sleepTimeValue);
			systemSetting.setMaskTypeValue((int)maskTypeValue);
			systemSetting.setThresHoldValue((int)thresHoldValue);

			systemSetting.setMaskDataUpdate();
			AppDelegate.dismissGlobalHUD();
			UIAlertController noticeAlert = UIAlertController.Create("Success", "Saved successfully", UIAlertControllerStyle.Alert);
			noticeAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
			PresentViewController(noticeAlert, true, null);
		}
		partial void defaultBtnTapped(NSObject sender)
		{
			AppDelegate.showGlobalProgressHUDWithTitle("Saving...");

			systemSetting.clearAllMaskData();

			ResultCode res = mReader.DefaultParameter;
			if (res != ResultCode.NoError)
			{
				UIAlertController noticeAlert = UIAlertController.Create("Fail", "Set to default failed", UIAlertControllerStyle.Alert);
				noticeAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
				PresentViewController(noticeAlert, true, null);
				return;
			}
			if (isJapan)
			{
				foreach (LbtItem lbtItem in lbtItemData)
				{
					lbtItem.MIsUsed = true;
				}
				mReader.SetLBT(lbtItemData.ToArray());
			}
			buzzerValue = mReader.Buzzer;
			vibratorValue = mReader.Vibrator;
			inventoryTimeValue = mReader.InventoryTime;
			idleTimeValue = mReader.IdleTime;
			autoOffTimeValue = mReader.AutoOffTime;
			qValue = mReader.QValue;
			maxQValue = mReader.MaxQ;
			minQValue = mReader.MinQ;
			sleepTimeValue = mReader.SleepTime;
			algorithmValue = mReader.Algorithm;
			linkProfileValue = mReader.LinkProfileValue;
			thresHoldValue = mReader.ThresHoldValue;
			defaultLinkProfileValue = mReader.DefaultLinkProfileValue;
			maskTypeValue = MaskType.NoMask;
			autoOffTimeValue = mReader.AutoOffTime;
			mReader.MaskTypeValue = (int)MaskType.NoMask;

			systemSetting.setBuzzer((int)buzzerValue);
			systemSetting.setVibrator((int)vibratorValue);
			systemSetting.setInventoryTime((int)inventoryTimeValue);
			systemSetting.setIdleTime((int)idleTimeValue);
			systemSetting.setAutoOffTime((int)autoOffTimeValue);
			systemSetting.setQValue((int)qValue);
			systemSetting.setAlgorithm((int)algorithmValue);
			systemSetting.setMaxQ((int)maxQValue);
			systemSetting.setMinQ((int)minQValue);
			systemSetting.setSleepTime((int)sleepTimeValue);
			systemSetting.setMaskTypeValue((int)maskTypeValue);
			systemSetting.setLinkProfileValue((int)linkProfileValue);
			systemSetting.setSessionFlag(mReader.SessionFlag);
			systemSetting.setInventorySession((int)mReader.InventorySession);
			systemSetting.setOperationTime(mReader.OperationTime);
			systemSetting.setPowerGain(300);
			systemSetting.setThresHoldValue(50);

			UserData.setBatteryInterval("10000");
			initViewData();
			AppDelegate.dismissGlobalHUD();
			UIAlertController alert = UIAlertController.Create("Success", "Set to default successfully", UIAlertControllerStyle.Alert);
			alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, null));
			PresentViewController(alert, true, null);
		}
		partial void pickerCloseBtnTapped(NSObject sender)
		{
			hidePickerView();
		}
		partial void qValuePickerOkBtnTapped(NSObject sender)
		{
			nint idx = pickerView.SelectedRowInComponent(0);
			if (pickerView.Tag == PICKER_VIEW_MaxQValue)
				setMaxQ(idx);
			else if (pickerView.Tag == PICKER_VIEW_MinQValue)
                setMinQ(idx);
			else if (pickerView.Tag == PICKER_VIEW_QValue)
				setQ(idx);
			hidePickerView();
		}
		partial void algorithmPickerOkBtnTapped(NSObject sender)
		{
			nint idx = pickerView.SelectedRowInComponent(0);
			setAlgorithm(idx);
			hidePickerView();
		}
		partial void linkProfilePickerOkBtnTapped(NSObject sender)
		{
			nint idx = pickerView.SelectedRowInComponent(0);
			if (pickerView.Tag == PICKER_VIEW_Link_Profile)
			{
				setLinkProfile(idx);
				mReader.LinkProfileValue = linkProfileValue;
				systemSetting.setLinkProfileValue(linkProfileValue);
			}

			hidePickerView();
		}
		partial void buzzerPickerOkBtnTapped(NSObject sender)
		{
			nint idx = pickerView.SelectedRowInComponent(0);
			setBuzzer(idx);
			hidePickerView();
		}
		partial void vibratorPickerOkBtnTapped(NSObject sender)
		{
			nint idx = pickerView.SelectedRowInComponent(0);
			setVibrator(idx);
			hidePickerView();
		}
		partial void keyActionPickerOkBtnTapped(NSObject sender)
		{
			nint idx = pickerView.SelectedRowInComponent(0);
			setKeyAction(idx);
			hidePickerView();
		}
		partial void maskTypePickerOkBtnTapped(NSObject sender)
		{
			nint idx = pickerView.SelectedRowInComponent(0);
			setMaskType(idx);
			hidePickerView();
		}
		partial void lbtChannelBtnTapped(NSObject sender)
		{
			tableView.ReloadData();
			lbtChannelTableTopView.Hidden = false;
			tableView.Hidden = false;
			shadowView.Hidden = false;
		}
		partial void tableCloseBtnTapped(NSObject sender)
		{
			hideTableView();
		}
		partial void lbtChannelTableOkBtnTapped(NSObject sender)
		{
			hideTableView();
			mReader.SetLBT(lbtItemData.ToArray());
		}

//#pragma mark - Custom
		void showPickerView()
		{
			pickerView.Hidden = false;
			shadowView.Hidden = false;
		}
		void hidePickerView()
		{
			LinkProfileTableTopView.Hidden = true;
			algorithmPickerTopView.Hidden = true;
			qValuePickerTopView.Hidden = true;
			vibratorPickerTopView.Hidden = true;
			buzzerPickerTopView.Hidden = true;
			keyActionPickerTopView.Hidden = true;
			maskTypePickerTopView.Hidden = true;
			pickerView.Hidden = true;
			shadowView.Hidden = true;
		}
		void hideTableView()
		{
			lbtChannelTableTopView.Hidden = true;
			tableView.Hidden = true;
			shadowView.Hidden = true;
		}
		void setBuzzer(nint index)
		{
			buzzerTextField.Text = buzzerPickerData[index];
			buzzerValue = (BuzzerState)(uint)index;
		}
		void setVibrator(nint index)
		{
			vibratorTextField.Text = vibratorPickerData[index];
			vibratorValue = (VibratorState)(uint)index;
		}
		void setMinQ(nint index)
		{
			if (index > maxQValue) index = maxQValue;
			minQValueTextField.Text = qValuePickerData[index];
			minQValue = (int)index;
		}
		void setMaxQ(nint index)
		{
			if (index < minQValue) index = minQValue;
			maxQValueTextField.Text = qValuePickerData[index];
			maxQValue = (int)index;
		}
		void setLinkProfile(nint index)
		{
			linkProfileTextField.Text = linkProfilePickerData[index];
			linkProfileValue = (int)index;
		}
		void setQ(nint index)
		{
			qValueTextField.Text = qValuePickerData[index];
			qValue = (int)index;
		}
		void setAlgorithm(nint index)
		{
			algorithmTextField.Text = algorithmPickerData[index];
			algorithmValue = (AlgorithmType)(uint)index;
		}
		void setInventoryTime(string inventoryTime)
		{
			inventoryTimeTextField.Text = inventoryTime;
			inventoryTimeValue = int.Parse(inventoryTime);
		}
		void setIdleTime(string idleTime)
		{
			idleTimeTextField.Text = idleTime;
			idleTimeValue = int.Parse(idleTime);
		}
		void setAutoOffTime(string autoOffTime)
		{
			autoOffTimeTextField.Text = autoOffTime;
			autoOffTimeValue = int.Parse(autoOffTime);
		}
		void setKeyAction(nint index)
		{
			keyActionValue = (int)index;
		}

		void setBatteryInterval(string batteryInterval)
		{
			batteryIntervalTextField.Text = batteryInterval;
			batteryIntervalValue = batteryInterval;
		}
		void setSleepTime(string sleepTime)
		{
			sleepTimeTextField.Text = sleepTime;
			sleepTimeValue = int.Parse(sleepTime);
		}
		void setMaskType(nint index)
		{
			maskTypeTextField.Text = maskTypePickerData[index];
			maskTypeValue = (MaskType)(uint)index;
		}
		void setThresHold(string thresHold)
		{
			thresHoldTextField.Text = thresHold;
			thresHoldValue = int.Parse(thresHold);
        }
		void initViewData()
		{
			setMaxQ(maxQValue);
			setMinQ(minQValue);
			setMaskType((nint)(uint)maskTypeValue);
			setLinkProfile(linkProfileValue);
			linkProfileTextField.Text = linkProfileValue.ToString();
			setAlgorithm((nint)(uint)algorithmValue);
			setQ(qValue);
			setBuzzer((nint)(uint)buzzerValue);
			setVibrator((nint)(uint)vibratorValue);
			setInventoryTime(inventoryTimeValue.ToString());
			setIdleTime(idleTimeValue.ToString());
			setAutoOffTime(autoOffTimeValue.ToString());
			setSleepTime(sleepTimeValue.ToString());
			setThresHold(thresHoldValue.ToString());
			setBatteryInterval(UserData.getBatteryInterval());
		}
	}
}
