﻿using System;
using Foundation;

namespace AsReaderGun251GDemoApp
{
    public class RFMHelper : NSObject
    {
        public static string calculationTemp(string _sensCode, string _calibration)
        {
            if ((_sensCode == null) || (_calibration == null)) return "";
            _calibration = _calibration.ToUpper();

            string calibBinaryData = convertHexToBinary(_calibration);
            Console.WriteLine(" Sen Code1 : " + calibBinaryData);

            string calibBinaryCode1 = _calibration.Substring(0, 12);
            string calibBinaryTemp1 = _calibration.Substring(12, 11);
            string calibBinaryCode2 = _calibration.Substring(23, 12);
            string calibBinaryTemp2 = _calibration.Substring(35, 11);

            //binary to decimal
            NSNumber calibDecCode1 = convertBinaryStringToDecimalNumber(calibBinaryCode1);
            NSNumber calibDecCode2 = convertBinaryStringToDecimalNumber(calibBinaryCode2);
            NSNumber calibDecTemp1 = convertBinaryStringToDecimalNumber(calibBinaryTemp1);
            NSNumber calibDecTemp2 = convertBinaryStringToDecimalNumber(calibBinaryTemp2);

            int calibCode1 = Convert.ToInt32(calibBinaryCode1);
            int calibCode2 = Convert.ToInt32(calibDecCode2);
            int calibTemp1 = Convert.ToInt32(calibDecTemp1);
            int calibTemp2 = Convert.ToInt32(calibDecTemp2);
            int code = convertHexStringToInt(_sensCode);


            float temperatureVal = (float) (0.1 * ((calibTemp2 - calibTemp1) / (calibCode2 - calibCode1) * (code - calibCode1) + calibTemp1 - 800));

            return temperatureVal.ToString();
        }

        public static string calculationSensorCode(string _sensCode, string _tid)
        {
            if (_sensCode == null) return "";
            _sensCode = _sensCode.Substring(0, 4);
            int code =  convertHexStringToInt(_sensCode);
            return code.ToString();
        }

        public static string convertHexToBinary(string _hexString)
        {
            string returnString = "";
            _hexString = _hexString.ToLower();
            foreach (char c in _hexString)
            {
                switch (c)
                {
                    case '0': returnString += "0000"; break;
                    case '1': returnString += "0001"; break;
                    case '2': returnString += "0010"; break;
                    case '3': returnString += "0011"; break;
                    case '4': returnString += "0100"; break;
                    case '5': returnString += "0101"; break;
                    case '6': returnString += "0110"; break;
                    case '7': returnString += "0111"; break;
                    case '8': returnString += "1000"; break;
                    case '9': returnString += "1001"; break;
                    case 'a': returnString += "1010"; break;
                    case 'b': returnString += "1011"; break;
                    case 'c': returnString += "1100"; break;
                    case 'd': returnString += "1101"; break;
                    case 'e': returnString += "1110"; break;
                    case 'f': returnString += "1111"; break;
                    default: break;
                }
            }
            return returnString;
        }

        public static NSNumber convertBinaryStringToDecimalNumber(string _binaryString)
        {
            int totalValue = 0;
            char[] arr = _binaryString.ToCharArray();
            for (int i = 0; i < _binaryString.Length; i++)
            {

                totalValue += (int)((arr[_binaryString.Length - 1 - i] - 48) * Math.Pow(2, i));
            }
            return NSNumber.FromInt32(totalValue);

        }

        public static int convertHexStringToInt(string _hexString)
        {
            int outVal = int.Parse(_hexString, System.Globalization.NumberStyles.HexNumber);
            return outVal;
        }
    }
}
