﻿using System;
using System.Runtime.InteropServices;
using Foundation;

namespace AsReaderGun251GDemoApp
{
    public class RainTagHelper : NSObject
    {
        public static string getPC(NSData rawData)
        {
            byte[] ptr = rawData.ToArray();
            Marshal.Copy(rawData.Bytes, ptr, 0, Convert.ToInt32(rawData.Length));
            int startEPC = 0;
            string pc = "";
            string epc = "";
            int result = ptr[0] & 0x02;
            if (result != 0)
            {
                int result2 = ptr[2] & 0x01;
                if (result2 == 0x01)
                {
                    pc = "PC:" + ptr[0].ToString("X2") + ptr[1].ToString("X2") + ptr[2].ToString("X2") + ptr[3].ToString("X2") + ptr[4].ToString("X2") + ptr[5].ToString("X2");
                    startEPC = 6;
                }
                else
                {
                    pc = "PC:" + ptr[0].ToString("X2") + ptr[1].ToString("X2") + ptr[2].ToString("X2") + ptr[3].ToString("X2");
                    startEPC = 4;
                }
            }
            else
            {
                pc = "PC:" + ptr[0].ToString("X2") + ptr[1].ToString("X2");
                startEPC = 2;
            }
            string tag = "";
            for (int i = 0; i < (int)rawData.Length; i++) tag += (ptr[i] & 0xFF).ToString("X2");
            epc = tag.Substring(startEPC * 2).ToUpper();
            return pc;
        }

        public static string getEPC(NSData rawData)
        {
            byte[] ptr = rawData.ToArray();
            Marshal.Copy(rawData.Bytes, ptr, 0, Convert.ToInt32(rawData.Length));
            int startEPC = 0;
            string pc = "";
            string epc = "";

            int result = ptr[0] & 0x02;
            if (result != 0)
            {
                int result2 = ptr[2] & 0x01;
                if (result2 == 0x01)
                {
                    pc = "PC:" + ptr[0].ToString("X2") + ptr[1].ToString("X2") + ptr[2].ToString("X2") + ptr[3].ToString("X2") + ptr[4].ToString("X2") + ptr[5].ToString("X2");
                    startEPC = 6;
                }
                else
                {
                    pc = "PC:" + ptr[0].ToString("X2") + ptr[1].ToString("X2") + ptr[2].ToString("X2") + ptr[3].ToString("X2");
                    startEPC = 4;
                }
            }
            else
            {
                pc = "PC:" + ptr[0].ToString("X2") + ptr[1].ToString("X2");
                startEPC = 2;
            }

            string tag = "";
            for (int i = 0; i < (int)rawData.Length; i++) tag += (ptr[i] & 0xFF).ToString("X2");
            epc = tag.Substring(startEPC * 2).ToUpper();


            string returnVal = "";
            if ((ptr[0] & 0x01) == 0x01)
            {
                returnVal = "UII : " + epc;
            } else {
                returnVal = "EPC : " + epc;
            }
            return returnVal;
        }

        public static string getPCEPCWithoutXpc(NSData rawData)
        {
            byte[] bytePtr = rawData.ToArray();
            Marshal.Copy(rawData.Bytes, bytePtr, 0, Convert.ToInt32(rawData.Length));
            int startEPC = 0;
            string pc = "";
            string epc = "";
            pc = "PC:" + bytePtr[0].ToString() + bytePtr[1].ToString();

            int result = bytePtr[0] & 0x02;
            if (result != 0)
            {
                int result2 = bytePtr[2] & 0x01;
                if (result2 == 0x01)
                {
                    startEPC = 6;
                }
                else
                {
                    startEPC = 4;
                }
            }
            else
            {
                startEPC = 2;
            }
            string tag = "";
            for (int i = 0; i < (int)rawData.Length; i++) tag += (bytePtr[i] & 0xFF).ToString("X2");
            try
            {
                epc = tag.Substring(startEPC * 2).ToUpper();
            }
            catch
            {
                epc = "Unknown";
            }
            return pc + epc;
        }

        public static bool checkSameTag1(NSData _compare1, NSData _compare2)
        {

            string com1 = getPCEPCWithoutXpc(_compare1);
            string com2 = getPCEPCWithoutXpc(_compare2);
            if (com1 == com2)
            {
                return true;
            }
            return false;
        }

        public static NSData dataFromHexString(string str)
        {
            if ((str.Length % 2) != 0)
                str = "0" + str;
            byte[] returnBytes = new byte[str.Length / 2];
            for (int i = 0; i < returnBytes.Length; i++)
                returnBytes[i] = Convert.ToByte(str.Substring(i * 2, 2), 16);
            return NSData.FromArray(returnBytes);
        }

        public static string getPCStringData(string _rawData)
        {
            NSData data = dataFromHexString(_rawData);
            return getPC(data);
        }

        public static string getEPCStringData(string _rawData)
        {
            NSData data = dataFromHexString(_rawData);
            return getEPC(data);
        }

        public static bool checkSameStringDataTag1(string _compare1, string _compare2)
        {
            NSData data1 = dataFromHexString(_compare1);
            NSData data2 = dataFromHexString(_compare2);
            return checkSameTag1(data1, data2);
        }

        public static string convertUniqueStringDataTag(string _rawData)
        {
            NSData data = dataFromHexString(_rawData);
            byte[] ptr = new byte[data.Length];
            Marshal.Copy(data.Bytes, ptr, 0, Convert.ToInt32(data.Length));
            string pc = "PC:" + ptr[0] + ptr[1];
            string epc = getEPC(data);
            return pc + epc;
        }

    }
}
