// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;
using System.Collections.Generic;

namespace AsReaderGun251GDemoApp
{
    public partial class ReadMemoryViewController : UIViewController
    {
        readonly int                PICKER_VIEW_BANK = 0;
        readonly int                PICKER_VIEW_OFFSET = 1;
        readonly int                PICKER_VIEW_LENGTH = 2;
        readonly int                PICKER_VIEW_POWER_GAIN = 3;
        readonly string             MSG_TAG_WAIT = "Tag memory to read or erase\nPlease click the button.";
        readonly AppDelegate        appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;
        bool                        isActionResult;
        MaskType                    maskType;
        readonly SystemSetting      systemSetting = SystemSetting.sharedSystemSetting();

        public string               maskValue;
        NSArray                     _offsetPickerData;
        NSArray                     _lengthPickerData;
        readonly List<string>       powerGainPickerData = new List<string>();
        int                         offsetValue;
        int                         lengthValue;

        UIAlertController           currentAlert;
        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public ReadMemoryViewController(IntPtr handle) : base(handle)
        {
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            pickerView.DataSource = new MyPickerViewDataSource(this);
            pickerView.Delegate = new MyPickerViewDelegate(this);

            int min = mReader.PowerGainRange.min;
            int max = mReader.PowerGainRange.max;

            for (int i = min; i <= max; i += 10)
                powerGainPickerData.Add((i / 10).ToString() + ".0 dB");
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }
        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
            gunManager.onAsReaderGUNDisconnected = () =>
            {
                AppDelegate.dismissGlobalHUD();
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };
            gunManager.onAsReaderGUNConnected = () =>
            {
                ViewDidAppear(true);
            };
            gunManager.accessResult = (error, action, epc, data, rssi, phase, frequency) =>
            {
                isActionResult = true;
                if (error != ResultCode.NoError)
                {
                    void ShowAlert()
                    {
                        currentAlert = UIAlertController.Create("Error", AsResultCode.Msg(error), UIAlertControllerStyle.Alert);
                        currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                        {
                            currentAlert = null;
                        }));
                        PresentViewController(currentAlert, true, null);
                    }

                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert());
                    else
                        ShowAlert();

                    return;
                }

                messageLabel.Text = "Success";
                selectionTagLabel.Text = epc;

                address1Label.Text = offsetValue.ToString() + " WORD";
                address2Label.Text = (offsetValue + 1).ToString() + " WORD";
                address3Label.Text = (offsetValue + 2).ToString() + " WORD";
                address4Label.Text = (offsetValue + 3).ToString() + " WORD";
                address5Label.Text = (offsetValue + 4).ToString() + " WORD";
                address6Label.Text = (offsetValue + 5).ToString() + " WORD";
                address7Label.Text = (offsetValue + 6).ToString() + " WORD";
                address8Label.Text = (offsetValue + 7).ToString() + " WORD";

                string[] bitLabel = data.Split(',');
                int bitLabelCount = bitLabel.Length;

                if (bitLabelCount >= 1)
                    value1Label.Text = bitLabel[0];
                else
                    value1Label.Text = "0000";

                if (bitLabelCount >= 2)
                    value2Label.Text = bitLabel[1];
                else
                    value2Label.Text = "0000";

                if (bitLabelCount >= 3)
                    value3Label.Text = bitLabel[2];
                else
                    value3Label.Text = "0000";

                if (bitLabelCount >= 4)
                    value4Label.Text = bitLabel[3];
                else
                    value4Label.Text = "0000";

                if (bitLabelCount >= 5)
                    value5Label.Text = bitLabel[4];
                else
                    value5Label.Text = "0000";

                if (bitLabelCount >= 6)
                    value6Label.Text = bitLabel[5];
                else
                    value6Label.Text = "0000";

                if (bitLabelCount >= 7)
                    value7Label.Text = bitLabel[6];
                else
                    value7Label.Text = "0000";

                if (bitLabelCount >= 8)
                    value8Label.Text = bitLabel[7];
                else
                    value8Label.Text = "0000";

                if (reportRssiSwitch.On == false)
                    SetReportRssiModeDefault();
                else
                {
                    rssiLabel.Text = Math.Round(rssi, 1).ToString() + " dB";
                    phaseLabel.Text = Math.Round(phase, 1).ToString() + "˚";
                }

                if (currentAlert != null)
                    currentAlert.DismissViewController(false, () =>
                    {
                        currentAlert = null;
                    });
            };
            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;

                return false;
            };
            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;

                return false;
            };
            gunManager.changedActionState = (action, resultCode) =>
            {
                if (action == CommandType.Stop)
                {
                    if (currentAlert != null)
                    {
                        currentAlert.DismissViewController(false, () =>
                        {
                            currentAlert = null;
                        });
                    }

                    if (isActionResult == false)
                        messageLabel.Text = MSG_TAG_WAIT;
                }
            };
            gunManager.onAsReaderTriggerKeyEvent = (status) =>
            {
                if (status)
                    ReadAction();

                return false;
            };
            gunManager.updateDeviceState = (error) =>
            {
                if (error != ResultCode.NoError)
                {
                    void ShowAlert()
                    {
                        currentAlert = UIAlertController.Create("Error", "Failed to get response. Try again.", UIAlertControllerStyle.Alert);
                        currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
                        {
                            currentAlert = null;
                        }));
                        PresentViewController(currentAlert, true, null);
                    }

                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert());
                    else
                        ShowAlert();
                    PerformSelector(new ObjCRuntime.Selector("pop2"), null, 1);
                }
            };
        }
        [Export("pop2")]
        void testPop2()
        {
            NavigationController.PopViewController(true);
        }

        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
            if (mReader == null) return;

            int nPower = mReader.PowerGain;
            int operationTime = mReader.OperationTime;
            mReader.ContinuousMode = false;
            bool isReportRSSI = mReader.RssiMode;
            maskType = (MaskType)mReader.MaskTypeValue;

            if (maskValue != null)
                gunManager.InitMask(maskValue, MaskType.Selection);

            isActionResult = false;
            SetPowerGain(nPower / 10);
            SetOperationTime(operationTime.ToString());
            SetBank(1);
            SetOffset(2);
            SetLength(2);
            SetReportRssiModeEnabled(isReportRSSI);
            pickerView.ReloadAllComponents();

            if (maskValue != null)
            {
                selectionTagLabel.Text = maskValue;
                maskBtn.Enabled = false;
            }
        }

        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();

            if (maskValue != null)
                gunManager.ExitMask();
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }

//#pragma mark - UIPickerViewDataSource

        private class MyPickerViewDataSource : UIPickerViewDataSource
        {
            readonly ReadMemoryViewController currentViewContorller;
            public MyPickerViewDataSource(ReadMemoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint GetComponentCount(UIPickerView pickerView)
            {
                //throw new NotImplementedException();
                return 1;
            }

            public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
            {
                //throw new NotImplementedException();
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BANK)
                    return currentViewContorller.appDelegate.DATA_BANK.Length;

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_OFFSET)
                    return currentViewContorller.appDelegate.DATA_BIT.Length;

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_LENGTH)
                    return (nint)currentViewContorller.LengthPickerData().Count;

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData.Count;

                return 0;
            }
        }

        private class MyPickerViewDelegate : UIPickerViewDelegate
        {
            ReadMemoryViewController currentViewContorller;
            public MyPickerViewDelegate(ReadMemoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override string GetTitle(UIPickerView pickerView, nint row, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BANK)
                    return currentViewContorller.appDelegate.DATA_BANK[row];

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_OFFSET)
                    return currentViewContorller.OffsetPickerData().GetItem<NSString>((uint)row).ToString();

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_LENGTH)
                    return currentViewContorller.LengthPickerData().GetItem<NSString>((uint)row).ToString();

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData[(int)row];

                return "None";
            }
        }
//#pragma mark - UITextViewDelegate
        private class MyTextFieldDelegate : UITextFieldDelegate
        {
            ReadMemoryViewController currentViewContorller;
            public MyTextFieldDelegate(ReadMemoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override bool ShouldChangeCharacters(UITextField textField, NSRange range, string replacementString)
            {
                if (range.Length == 1)
                {
                    return true;
                }
                long textlen = textField.Text.Length + replacementString.Length - range.Length;

                if (textlen > currentViewContorller.appDelegate.MAX_PASSWORD_LENGTH) return false;

                string a = "0123456789ABCDEFabcdef";

                if (a.IndexOf(replacementString) > -1)
                {
                    string str = textField.Text + replacementString;
                    textField.Text = str.ToUpper();
                }
                return false;
            }

        }

//#pragma mark - Getters
        NSArray OffsetPickerData()
        {
            if (_offsetPickerData == null)
            {
                NSMutableArray tmpArray = new NSMutableArray();

                foreach (string offset in appDelegate.DATA_WORD)
                {
                    string str = offset + " WORD";
                    tmpArray.Add(new NSString(str));
                }

                _offsetPickerData = tmpArray;
            }
            return _offsetPickerData;
        }

        NSArray LengthPickerData()
        {
            if (_lengthPickerData == null)
            {
                NSMutableArray tmpArray = new NSMutableArray();

                foreach (string offset in appDelegate.DATA_WORD)
                {
                    string str = offset + " WORD";
                    tmpArray.Add(new NSString(str));
                }

                _lengthPickerData = tmpArray;
            }
            return _lengthPickerData;
        }

//#pragma mark - IBAction
        partial void BankBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_BANK;
            pickerView.ReloadAllComponents();

            if (bankTextField.Text != "")
            {
                int index = Array.IndexOf(appDelegate.DATA_BANK, bankTextField.Text);
                pickerView.Select(index, 0, false);
            }
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            bankPickerTopView.Hidden = false;
        }
        partial void OffsetBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_OFFSET;
            pickerView.ReloadAllComponents();

            if (offsetTextField.Text != "")
                pickerView.Select((nint)OffsetPickerData().IndexOf(new NSString(offsetTextField.Text)), 0, false);
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            offsetPickerTopView.Hidden = false;
        }
        partial void LengthBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_LENGTH;
            pickerView.ReloadAllComponents();

            if (lengthTextField.Text != "")
                pickerView.Select((nint)LengthPickerData().IndexOf(new NSString(lengthTextField.Text)), 0, false);
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            lengthPickerTopView.Hidden = false;
        }
        partial void PasswordBtnTapped(NSObject _)
        {
            UIAlertController alert = UIAlertController.Create("Password", "Please enter password.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;
                SetPassword(str);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void PowerGainBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_POWER_GAIN;
            pickerView.ReloadAllComponents();

            if (powerGainTextField.Text != "")
                pickerView.Select(powerGainPickerData.IndexOf(new NSString(powerGainTextField.Text)), 0, false);
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            powerGainPickerTopView.Hidden = false;
        }
        partial void OperationTimeBtnTapped(NSObject _)
        {
            UIAlertController alert = UIAlertController.Create("Operation Time:", "Please enter operation time.\n(ex: 30 ms)", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.NumberPad;
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;
                if (str == "") str = "0";
                SetOperationTime(str);
                mReader.OperationTime = int.Parse(str);
                systemSetting.setOperationTime(int.Parse(str));
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void ReportRssiSwitchTapped(NSObject _)
        {
            mReader.RssiMode = reportRssiSwitch.On;
            systemSetting.setRssiMode(reportRssiSwitch.On);
            SetReportRssiModeEnabled(reportRssiSwitch.On);
        }
        partial void readBtnTapped(NSObject _)
        {
            ReadAction();
        }
        partial void BlockEraseBtnTapped(NSObject sender)
        {
            isActionResult = false;
            messageLabel.Text = "Erasing tag memory.\nPlease wait…";

            if (operationTimeTextField.Text == "")
                operationTimeTextField.Text = "0";

            mReader.OperationTime = int.Parse(operationTimeTextField.Text);
            systemSetting.setOperationTime(int.Parse(operationTimeTextField.Text));

            int index = Array.IndexOf(appDelegate.DATA_BANK, bankTextField.Text);
            MemoryBank bank = (MemoryBank)(uint)index;
            mReader.BlockErase(bank, offsetValue, lengthValue);
            ClearBtnTapped(sender);
        }
        partial void ClearBtnTapped(NSObject _)
        {
            selectionTagLabel.Text = "Result";
            messageLabel.Text = MSG_TAG_WAIT;

            address1Label.Text = @"0 WORD";
            address2Label.Text = @"1 WORD";
            address3Label.Text = @"2 WORD";
            address4Label.Text = @"3 WORD";
            address5Label.Text = @"4 WORD";
            address6Label.Text = @"5 WORD";
            address7Label.Text = @"6 WORD";
            address8Label.Text = @"7 WORD";

            value1Label.Text = @"0000";
            value2Label.Text = @"0000";
            value3Label.Text = @"0000";
            value4Label.Text = @"0000";
            value5Label.Text = @"0000";
            value6Label.Text = @"0000";
            value7Label.Text = @"0000";
            value8Label.Text = @"0000";

            rssiLabel.Text = @"0.0 dB";
            phaseLabel.Text = @"0.0˚";
        }
        partial void MaskBtnTapped(NSObject _)
        {
            if (maskType == MaskType.Selection)
                PerformSegue("SelectionMask", this);
            else
            {
                void ShowAlert()
                {
                    currentAlert = UIAlertController.Create("", "Please choosing the Selection Mask type in the RFID Option menu.", UIAlertControllerStyle.Alert);
                    currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                    {
                        currentAlert = null;
                    }));
                    PresentViewController(currentAlert, true, null);
                }
                if (currentAlert != null)
                    currentAlert.DismissViewController(false, () => ShowAlert());
                else
                    ShowAlert();
            }
        }
        partial void PickerCloseBtnTapped(NSObject _)
        {
            HidePickerView();
        }
        partial void BankPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            SetBank(idx);
            HidePickerView();
        }
        partial void OffsetPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            SetOffset(idx);
            HidePickerView();
        }
        partial void LengthPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            SetLength(idx);
            HidePickerView();
        }
        partial void PowerGainPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            idx += mReader.PowerGainRange.min / 10;
            SetPowerGain(idx);
            mReader.PowerGain = (int)idx * 10;
            systemSetting.setPowerGain((int)idx * 10);
            HidePickerView();
        }
//#pragma mark - Custom
        void HidePickerView()
        {
            bankPickerTopView.Hidden = true;
            offsetPickerTopView.Hidden = true;
            lengthPickerTopView.Hidden = true;
            powerGainPickerTopView.Hidden = true;
            pickerView.Hidden = true;
        }
        void SetBank(nint index)
        {
            bankTextField.Text = appDelegate.DATA_BANK[index];
        }
        void SetOffset(nint index)
        {
            offsetTextField.Text = OffsetPickerData().GetItem<NSString>((uint)index).ToString();
            offsetValue = (int)index;
        }
        void SetLength(nint index)
        {
            lengthTextField.Text = LengthPickerData().GetItem<NSString>((uint)index).ToString();
            lengthValue = (int)index;
        }
        void SetPassword(string password)
        {
            passwordTextField.Text = password;
        }
        void SetPowerGain(nint power)
        {
            NSString value = new NSString(power.ToString() + ".0 dB");
            int index = powerGainPickerData.IndexOf(value);

            if (powerGainPickerData.Count > index)
                powerGainTextField.Text = powerGainPickerData[index];
        }
        void SetOperationTime(string operationTime)
        {
            operationTimeTextField.Text = operationTime;
        }
        void ReadAction()
        {
            isActionResult = false;
            messageLabel.Text = "Reading tag memory.\nPlease wait…";

            if (operationTimeTextField.Text == "")
                operationTimeTextField.Text = "0";

            mReader.OperationTime = int.Parse(operationTimeTextField.Text);
            systemSetting.setOperationTime(int.Parse(operationTimeTextField.Text));

            int index = Array.IndexOf(appDelegate.DATA_BANK, bankTextField.Text);
            MemoryBank bank = (MemoryBank)(uint)index;
            mReader.AccessPassword = passwordTextField.Text;
            mReader.ReadMemory(bank, offsetValue, lengthValue);

            void ShowAlert()
            {
                currentAlert = UIAlertController.Create("Please wait...", "Reading tag memory", UIAlertControllerStyle.Alert);
                currentAlert.AddAction(UIAlertAction.Create("Stop", UIAlertActionStyle.Default, Action =>
                {
                    StopAction();
                    currentAlert = null;
                }));
                PresentViewController(currentAlert, true, null);
            }

            if (currentAlert != null)
                currentAlert.DismissViewController(false, () => ShowAlert());
            else
                ShowAlert();
        }
        void StopAction()
        {
            _ = mReader.Stop;
        }
        void SetReportRssiModeEnabled(bool enabled)
        {
            foreach (UILabel elem in reportRssiCollection)
                elem.Enabled = enabled;

            if (enabled == false)
                SetReportRssiModeDefault();

            reportRssiSwitch.On = enabled;
        }
        void SetReportRssiModeDefault()
        {
            rssiLabel.Text = "0.0 dB";
            phaseLabel.Text = "0.0˚";
        }
    }

}