// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;

namespace AsReaderGun251GDemoApp
{
	public partial class RegionSettingViewController : UITableViewController
	{
        readonly string[] regionList = {"USA", "Australia", "Japan", "Brazil", "Europe" };
        String currentRegion = "";
        int selectedIndex = 0;
        readonly AppDelegate     appDelegate = (AppDelegate) UIApplication.SharedApplication.Delegate;
        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
		private AsReader mReader
		{
			get => gunManager.GetCurrentAsReader();
		}
		public RegionSettingViewController(IntPtr handle) : base(handle)
		{
		}
		public override void ViewDidLoad()
		{
			base.ViewDidLoad();
            currentRegion = mReader.RegionName;
            NavigationItem.Title = currentRegion;
            regionTableView.DataSource = new MyTableViewSource(this);
            regionTableView.Delegate = new MyTableViewDelegate(this);
            gunManager.onAsReaderGUNDisconnected = () =>
            {
                NavigationController.PopToRootViewController(true);
            };
        }
        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();
        }
        private void UpdateRegion(int region, String name)
        {
            UIAlertController alert = UIAlertController.Create("Change Region", name, UIAlertControllerStyle.Alert);
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                AppDelegate.showGlobalProgressHUDWithTitle("Please wait (MAX 40s)");
                ResultCode result = mReader.ChangeRegion(region);
                AppDelegate.dismissGlobalHUD();
                String title = "";
                String message = "";
                if (result == ResultCode.NoError) {
                    title = "Success";
                    message = "Press the power button once.The reader turns on again.";
                } else if (result == ResultCode.NotSupportFirmware)
                {
                    title = "Setting fail";
                    message = " NOT SUPPORTED REGION";
                } else
                {
                    title = "Setting fail";
                    message = "Please try again";
                }
                UIAlertController alert2 = UIAlertController.Create(title, message, UIAlertControllerStyle.Alert);
                alert2.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, null));
                PresentViewController(alert2, true, null);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, Action =>
            {
                alert.DismissViewController(true, null);
            }));
            PresentViewController(alert, true, null);
         }

        //#pragma mark - UITableViewDataSource
        private class MyTableViewSource : UITableViewDataSource
        {
            RegionSettingViewController currentViewContorller;
            public MyTableViewSource(RegionSettingViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint NumberOfSections(UITableView tableView)
            {
                return 1;
            }

            public override nint RowsInSection(UITableView tableView, nint section)
            {
                return (nint)currentViewContorller.regionList.Length;
            }

            public override UITableViewCell GetCell(UITableView tableView, NSIndexPath indexPath)
            {
                UITableViewCell cell = (UITableViewCell)tableView.DequeueReusableCell("RegionCell", indexPath);
                cell.TextLabel.Text = currentViewContorller.regionList[indexPath.Row];
                return cell;
            }
        }
        //#pragma mark - UITableViewDelegate
        class MyTableViewDelegate : UITableViewDelegate
        {
            readonly RegionSettingViewController currentViewContorller;
            public MyTableViewDelegate(RegionSettingViewController controller)
            {
                currentViewContorller = controller;
            }

            public override void RowSelected(UITableView tableView, NSIndexPath indexPath)
            {
                currentViewContorller.selectedIndex = indexPath.Row;
                switch (currentViewContorller.selectedIndex)
                {
                    case 0:
                        currentViewContorller.UpdateRegion(2, "US");
                        break;
                    case 1:
                        currentViewContorller.UpdateRegion(14, "Australia");
                        break;
                    case 2:
                        currentViewContorller.UpdateRegion(8, "Japan");
                        break;
                    case 3:
                        currentViewContorller.UpdateRegion(5, "Brazil");
                        break;
                    case 4:
                        currentViewContorller.UpdateRegion(1, "Europe");
                        break;
                    default:
                        break;
                }
            }
        }
    }
}
