// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;
using System.Collections.Generic;

namespace AsReaderGun251GDemoApp
{
	public partial class TagAccessViewController : UIViewController
	{
        public string               maskValue;
        readonly int                PICKER_VIEW_POWER_GAIN = 0;
        readonly string             MSG_TAG_WAIT = "Tag memory to lock or kill,\nPlease click the button";
        readonly AppDelegate        appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;
        bool                        isActionResult;
        MaskType                    maskType;
        readonly SystemSetting      systemSetting = SystemSetting.sharedSystemSetting();
        UIAlertController           currentAlert;
        readonly List<string>       powerGainPickerData = new List<string>();
        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public TagAccessViewController (IntPtr handle) : base (handle)
		{
		}

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            pickerView.DataSource = new MyPickerViewDataSource(this);
            pickerView.Delegate = new MyPickerViewDelegate(this);

            int min = mReader.PowerGainRange.min;
            int max = mReader.PowerGainRange.max;

            for (int i = min; i <= max; i += 10)
                powerGainPickerData.Add((i / 10).ToString() + ".0 dB");
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }

        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
            gunManager.onAsReaderGUNDisconnected = () =>
            {
                AppDelegate.dismissGlobalHUD();
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };
            gunManager.onAsReaderGUNConnected = () =>
            {
                ViewDidAppear(true);
            };
            gunManager.accessResult = (error, action, epc, data, rssi, phase, frequency) =>
            {
                isActionResult = true;

                void ShowAlert(string title, string message)
                {
                    currentAlert = UIAlertController.Create(title, message, UIAlertControllerStyle.Alert);
                    currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
                    {
                        currentAlert = null;
                    }));
                    PresentViewController(currentAlert, true, null);
                }

                if (error != ResultCode.NoError)
                {
                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert("Error", AsResultCode.Msg(error)));
                    else
                        ShowAlert("Error", AsResultCode.Msg(error));

                    return;
                }

                messageLabel.Text = "Success";
                selectionTagLabel.Text = epc;

                if (!reportRssiSwitch.On)
                    SetReportRssiModeDefault();
                else
                {
                    rssiLabel.Text = Math.Round(rssi, 1).ToString() + " dB";
                    phaseLabel.Text = Math.Round(phase, 1).ToString() + "˚";
                }
                if (currentAlert != null)
                    currentAlert.DismissViewController(false, null);
            };
            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;

                return false;
            };
            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;

                return false;
            };
            gunManager.changedActionState = (action, resultCode) =>
            {
                if (currentAlert != null)
                {
                    currentAlert.DismissViewController(false, () => {
                        currentAlert = null;
                    });
                }
                if (action == CommandType.Stop)
                {
                    if (isActionResult == false)
                        messageLabel.Text = MSG_TAG_WAIT;
                }
            };
            gunManager.onAsReaderTriggerKeyEvent = (status) =>
            {
                if (status)
                {
                    void ShowAlert()
                    {
                        currentAlert = UIAlertController.Create("Error", "For this page no Trigger key function.", UIAlertControllerStyle.Alert);
                        currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, _ =>
                        {
                            currentAlert = null;
                        }));
                        PresentViewController(currentAlert, true, null);
                    }
                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert());
                    else
                        ShowAlert();
                }
                return false;
            };
            gunManager.updateDeviceState = (error) =>
            {
                if (error != ResultCode.NoError)
                {
                    void ShowAlert()
                    {
                        currentAlert = UIAlertController.Create("Error", "Failed to get response. Try again.", UIAlertControllerStyle.Alert);
                        currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, _ =>
                        {
                            PerformSelector(new ObjCRuntime.Selector("pop2"), null, 1);
                            currentAlert = null;
                        }));
                        PresentViewController(currentAlert, true, null);
                    }
                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert());
                    else
                        ShowAlert();
                }
            };
        }

        [Export("pop2")]
        void testPop2()
        {
            NavigationController.PopViewController(true);
        }
        public override void ViewDidAppear(bool animated)
        {

            base.ViewDidAppear(animated);
            if (mReader == null) return;

            AppDelegate.showGlobalProgressHUDWithTitle("Loading...");

            int nPower = mReader.PowerGain;
            int operationTime = mReader.OperationTime;
            mReader.ContinuousMode = false;
            bool isReportRSSI = mReader.RssiMode;
            maskType = (MaskType)mReader.MaskTypeValue;

            if (maskValue != null)
                gunManager.InitMask(maskValue, MaskType.Selection);

            isActionResult = false;
            SetPowerGain(nPower / 10);
            SetOperationTime(operationTime.ToString());
            SetReportRssiModeEnabled(isReportRSSI);
            pickerView.ReloadAllComponents();

            if (maskValue != null)
            {
                selectionTagLabel.Text = maskValue;
                maskBtn.Enabled = false;
            }
            AppDelegate.dismissGlobalHUD();
        }

        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();
            if (maskValue != null) gunManager.ExitMask();
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }

//#pragma mark - UIPickerViewDataSource
        private class MyPickerViewDataSource : UIPickerViewDataSource
        {
            TagAccessViewController currentViewContorller;
            public MyPickerViewDataSource(TagAccessViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint GetComponentCount(UIPickerView pickerView)
            {
                return 1;
            }

            public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData.Count;

                return 0;
            }
        }

        private class MyPickerViewDelegate : UIPickerViewDelegate
        {
            TagAccessViewController currentViewContorller;
            public MyPickerViewDelegate(TagAccessViewController controller)
            {
                currentViewContorller = controller;
            }

            public override string GetTitle(UIPickerView pickerView, nint row, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData[(int)row];

                return "None";
            }
        }
//#pragma mark - UITextViewDelegate
        private class MyTextFieldDelegate : UITextFieldDelegate
        {
            TagAccessViewController currentViewContorller;
            public MyTextFieldDelegate(TagAccessViewController controller)
            {
                currentViewContorller = controller;
            }

            public override bool ShouldChangeCharacters(UITextField textField, NSRange range, string replacementString)
            {
                if (range.Length == 1) return true;

                long textlen = textField.Text.Length + replacementString.Length - range.Length;
                
                if (textlen > currentViewContorller.appDelegate.MAX_PASSWORD_LENGTH) return false;

                string a = "0123456789ABCDEFabcdef";

                if (a.IndexOf(replacementString) > -1)
                {
                    string str = textField.Text + replacementString;
                    textField.Text = str.ToUpper();
                }
                return false;
            }
        }

//#pragma mark - IBAction
        partial void PasswordBtnTapped(NSObject _)
        {
            UIAlertController alert = UIAlertController.Create("Password", "Please enter password.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;
                SetPassword(str);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void PowerGainBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_POWER_GAIN;

            pickerView.ReloadAllComponents();

            if (powerGainTextField.Text != "")
                pickerView.Select(powerGainPickerData.IndexOf(new NSString(powerGainTextField.Text)), 0, false);
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            powerGainPickerTopView.Hidden = false;
        }
        partial void OperationTimeBtnTapped(NSObject _)
        {
            UIAlertController alert = UIAlertController.Create("Operation Time:", "Please enter operation time.\n(ex: 30 ms)", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.NumberPad;
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;

                if (str == "")
                    str = "0";

                SetOperationTime(str);
                mReader.OperationTime = int.Parse(str);
                systemSetting.setOperationTime(int.Parse(str));
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void ReportRssiSwitchTapped(NSObject _)
        {
            mReader.RssiMode = reportRssiSwitch.On;
            systemSetting.setRssiMode(reportRssiSwitch.On);
            SetReportRssiModeEnabled(reportRssiSwitch.On);
        }
        partial void LockBtnTapped(NSObject _)
        {
            isActionResult = false;
            mReader.AccessPassword = passwordTextField.Text;

            LockParam param = new LockParam();
            param.KillPassword = killPasswordSwitch.On;
            param.AccessPassword = accessPasswordSwitch.On;
            param.Epc = epcSwitch.On;
            param.Tid = tidSwitch.On;
            param.User = userSwitch.On;

            if (operationTimeTextField.Text == "")
                operationTimeTextField.Text = "0";

            int time = int.Parse(operationTimeTextField.Text);
            mReader.OperationTime = time;
            systemSetting.setOperationTime(time);
            mReader.Lock(param);
        }
        partial void UnlockBtnTapped(NSObject _)
        {
            isActionResult = false;
            mReader.AccessPassword = passwordTextField.Text;

            LockParam param = new LockParam();
            param.KillPassword = killPasswordSwitch.On;
            param.AccessPassword = accessPasswordSwitch.On;
            param.Epc = epcSwitch.On;
            param.Tid = tidSwitch.On;
            param.User = userSwitch.On;

            if (operationTimeTextField.Text == "")
                operationTimeTextField.Text = "0";

            int time = int.Parse(operationTimeTextField.Text);

            mReader.OperationTime = time;
            systemSetting.setOperationTime(time);
            mReader.Unlock(param);
        }
        partial void PermalockBtnTapped(NSObject _)
        {
            isActionResult = false;
            mReader.AccessPassword = passwordTextField.Text;

            LockParam param = new LockParam();
            param.KillPassword = killPasswordSwitch.On;
            param.AccessPassword = accessPasswordSwitch.On;
            param.Epc = epcSwitch.On;
            param.Tid = tidSwitch.On;
            param.User = userSwitch.On;
            if (operationTimeTextField.Text == "") operationTimeTextField.Text = "0";
            int time = int.Parse(operationTimeTextField.Text);

            mReader.OperationTime = time;
            systemSetting.setOperationTime(time);
            mReader.PermaLock(param);
        }
        partial void KillBtnTapped(NSObject _)
        {
            isActionResult = false;

            UIAlertController alert = UIAlertController.Create("Kill Password:", "Please enter password.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;

                if (str == "")
                    str = "0";

                if (str.Length != 8)
                {
                    void ShowAlert()
                    {
                        currentAlert = UIAlertController.Create("Error", "Password length is not valid", UIAlertControllerStyle.Alert);
                        currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, _Action =>
                        { 
                            currentAlert = null;
                        }));
                        PresentViewController(currentAlert, true, null);
                    }
                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert());
                    else
                        ShowAlert();
                }
                else
                    mReader.Kill(str);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void SetAccessPwdBtnTapped(NSObject _)
        {
            isActionResult = false;

            UIAlertController alert = UIAlertController.Create("Set Access Password:", "Please enter password.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;

                if (str == "")
                    str = "0";

                mReader.AccessPassword = passwordTextField.Text;
                mReader.WriteMemory(MemoryBank.Reserved, 2, str);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void SetKillPwdBtnTapped(NSObject _)
        {
            isActionResult = false;

            UIAlertController alert = UIAlertController.Create("Set Kill Password:", "Please enter password.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;

                if (str == "")
                    str = "0";

                mReader.AccessPassword = passwordTextField.Text;
                mReader.WriteMemory(MemoryBank.Reserved, 0, str);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void ClearBtnTapped(NSObject _)
        {
            selectionTagLabel.Text = "Result";
            messageLabel.Text = MSG_TAG_WAIT;
            rssiLabel.Text = @"0.0 dB";
            phaseLabel.Text = @"0.0˚";
        }
        partial void MaskBtnTapped(NSObject _)
        {
            if (maskType == MaskType.Selection)
                PerformSegue("SelectionMask", this);
            else
            {
                void ShowAlert()
                {
                    currentAlert = UIAlertController.Create("", "Please choosing the Selection Mask type in the RFID Option menu.", UIAlertControllerStyle.Alert);
                    currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                    {
                        currentAlert = null;
                    }));
                    PresentViewController(currentAlert, true, null);
                }
                if (currentAlert != null)
                    currentAlert.DismissViewController(false, () => ShowAlert());
                else
                    ShowAlert();
            }
        }
        partial void PickerCloseBtnTapped(NSObject _)
        {
            HidePickerView();
        }
        partial void powerGainPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            idx += mReader.PowerGainRange.min / 10;
            SetPowerGain(idx);
            mReader.PowerGain = (int)idx * 10;
            systemSetting.setPowerGain((int)idx * 10);
            HidePickerView();
        }
//#pragma mark - Custom
        void HidePickerView()
        {
            powerGainPickerTopView.Hidden = true;
            pickerView.Hidden = true;
        }
        void SetPassword(string password)
        {
            passwordTextField.Text = password;
        }
        void SetPowerGain(nint power)
        {
            NSString value = new NSString(power.ToString() + ".0 dB");
            int index = powerGainPickerData.IndexOf(value);

            if (powerGainPickerData.Count > index)
                powerGainTextField.Text = powerGainPickerData[index];
        }
        void SetOperationTime(string operationTime)
        {
            operationTimeTextField.Text = operationTime;
        }
        void StopAction()
        {
            _ = mReader.Stop;
        }
        void SetReportRssiModeEnabled(bool enabled)
        {
            foreach (UILabel elem in reportRssiCollection)
                elem.Enabled = enabled;

            if (enabled == false)
                SetReportRssiModeDefault();

            reportRssiSwitch.On = enabled;
        }
        void SetReportRssiModeDefault()
        {
            rssiLabel.Text = "0.0 dB";
            phaseLabel.Text = "0.0˚";
        }
    }
}
