// This file has been autogenerated from a class added in the UI designer.

using System;
using AsReaderGun251GSDK;
using Foundation;
using UIKit;
using System.Collections.Generic;

namespace AsReaderGun251GDemoApp
{
	public partial class WriteMemoryViewController : UIViewController
	{
        public string               maskValue;
        readonly int                PICKER_VIEW_BANK = 0;
        readonly int                PICKER_VIEW_OFFSET = 1;
        readonly int                PICKER_VIEW_POWER_GAIN = 2;
        readonly int                TEXT_FIELD_WRITE_DATA = 10;
        readonly int                TEXT_FIELD_PASSWORD = 11;
        readonly string             MSG_TAG_WAIT = "Tag memory to write\nPlease click the button.";
        readonly AppDelegate        appDelegate = (AppDelegate)UIApplication.SharedApplication.Delegate;
        int                         isEditing;
        bool                        isActionResult;
        MaskType                    maskType;
        readonly SystemSetting      systemSetting = SystemSetting.sharedSystemSetting();

        NSArray                     _offsetPickerData;
        readonly List<string>       powerGainPickerData = new List<string>();
        int                         offsetValue;

        UIAlertController           currentAlert;
        readonly AsReaderGUNManager gunManager = AsReaderGUNManager.SharedAsReaderGUNManager();
        private AsReader mReader
        {
            get => gunManager.GetCurrentAsReader();
        }

        public WriteMemoryViewController (IntPtr handle) : base (handle)
		{
		}

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            pickerView.DataSource = new MyPickerViewDataSource(this);
            pickerView.Delegate = new MyPickerViewDelegate(this);

            int min = mReader.PowerGainRange.min;
            int max = mReader.PowerGainRange.max;

            for (int i = min; i <= max; i += 10)
                powerGainPickerData.Add((i / 10).ToString() + ".0 dB");
        }
        [Export("pop")]
        void testPop()
        {
            NavigationController.PopToRootViewController(true);
        }

        public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
            gunManager.onAsReaderGUNDisconnected = () =>
            {
                AppDelegate.dismissGlobalHUD();
                PerformSelector(new ObjCRuntime.Selector("pop"), null, 1);
            };
            gunManager.onAsReaderGUNConnected = () =>
            {
                ViewDidAppear(true);
            };
            gunManager.accessResult = (error, action, epc, data, rssi, phase, frequency) =>
            {
                isActionResult = true;

                if (error != ResultCode.NoError)
                {
                    void ShowAlert()
                    {
                        currentAlert = UIAlertController.Create("Error", AsResultCode.Msg(error), UIAlertControllerStyle.Alert);
                        currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
                        {
                            currentAlert = null;
                        }));
                        PresentViewController(currentAlert, true, null);
                    }

                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert());
                    else
                        ShowAlert();
                    return;
                }

                messageLabel.Text = "Success";
                selectionTagLabel.Text = epc;

                if (reportRssiSwitch.On == false)
                    SetReportRssiModeDefault();
                else
                {
                    rssiLabel.Text = Math.Round(rssi, 1).ToString() + " dB";
                    phaseLabel.Text = Math.Round(phase, 1).ToString() + "˚";
                }

                if (currentAlert != null)
                {
                    currentAlert.DismissViewController(false, () => {
                        currentAlert = null;
                    });
                }
            };
            gunManager.onAsReaderLeftModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;

                return false;
            };
            gunManager.onAsReaderRightModeKeyEvent = (status) =>
            {
                if (mReader.IsRFIDModule && mReader.IsBarcodeModule) return true;

                return false;
            };
            gunManager.changedActionState = (action, resultCode) =>
            {
                if (action == CommandType.Stop)
                {
                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => {
                            currentAlert = null;
                        });

                    if (isActionResult == false)
                        messageLabel.Text = MSG_TAG_WAIT;
                }
            };
            gunManager.onAsReaderTriggerKeyEvent = (status) =>
            {
                if (status)
                    WriteBtnTapped(null);

                return false;
            };
            gunManager.updateDeviceState = (error) =>
            {
                if (error != ResultCode.NoError)
                {

                    void ShowAlert()
                    {
                        currentAlert = UIAlertController.Create("Error", "Failed to get response. Try again.", UIAlertControllerStyle.Alert);
                        currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                        {
                            currentAlert = null;
                        }));
                        PresentViewController(currentAlert, true, null);
                    }
                    if (currentAlert != null)
                        currentAlert.DismissViewController(false, () => ShowAlert());
                    else
                        ShowAlert();
                    PerformSelector(new ObjCRuntime.Selector("pop2"), null, 1);
                }
            };
        }
        [Export("pop2")]
        void testPop2()
        {
            NavigationController.PopViewController(true);
        }

        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
            if (mReader == null) return;

            int nPower = mReader.PowerGain;
            int operationTime = mReader.OperationTime;
            mReader.ContinuousMode = false;
            bool isReportRSSI = mReader.RssiMode;
            maskType = (MaskType)mReader.MaskTypeValue;

            if (maskValue != null)
                gunManager.InitMask(maskValue, MaskType.Selection);

            isActionResult = false;
            SetPowerGain(nPower / 10);
            SetOperationTime(operationTime.ToString());
            SetBank(1);
            SetOffset(2);
            SetReportRssiModeEnabled(isReportRSSI);
            pickerView.ReloadAllComponents();

            if (maskValue != null)
            {
                selectionTagLabel.Text = maskValue;
                maskBtn.Enabled = false;
            }
        }

        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
            gunManager.ResetDelegate();

            if (maskValue != null)
                gunManager.ExitMask();
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }

//#pragma mark - UIPickerViewDataSource
        private class MyPickerViewDataSource : UIPickerViewDataSource
        {
            WriteMemoryViewController currentViewContorller;
            public MyPickerViewDataSource(WriteMemoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override nint GetComponentCount(UIPickerView pickerView)
            {
                //throw new NotImplementedException();
                return 1;
            }

            public override nint GetRowsInComponent(UIPickerView pickerView, nint component)
            {
                //throw new NotImplementedException();
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BANK)
                    return currentViewContorller.appDelegate.DATA_BANK.Length;

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_OFFSET)
                    return currentViewContorller.appDelegate.DATA_BIT.Length;

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData.Count;

                return 0;
            }
        }

        private class MyPickerViewDelegate : UIPickerViewDelegate
        {
            WriteMemoryViewController currentViewContorller;
            public MyPickerViewDelegate(WriteMemoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override string GetTitle(UIPickerView pickerView, nint row, nint component)
            {
                if (pickerView.Tag == currentViewContorller.PICKER_VIEW_BANK)
                    return currentViewContorller.appDelegate.DATA_BANK[row];

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_OFFSET)
                    return currentViewContorller.OffsetPickerData().GetItem<NSString>((uint)row).ToString();

                else if (pickerView.Tag == currentViewContorller.PICKER_VIEW_POWER_GAIN)
                    return currentViewContorller.powerGainPickerData[(int)row];

                return "None";
            }
        }

//#pragma mark - UITextViewDelegate
        private class MyTextFieldDelegate : UITextFieldDelegate
        {
            WriteMemoryViewController currentViewContorller;
            public MyTextFieldDelegate(WriteMemoryViewController controller)
            {
                currentViewContorller = controller;
            }

            public override bool ShouldChangeCharacters(UITextField textField, NSRange range, string replacementString)
            {
                if (range.Length == 1) return true;

                long textlen = textField.Text.Length + replacementString.Length - range.Length;

                if (currentViewContorller.isEditing == currentViewContorller.TEXT_FIELD_PASSWORD &&
                    textlen > currentViewContorller.appDelegate.MAX_PASSWORD_LENGTH) return false;
                else if (currentViewContorller.isEditing == currentViewContorller.TEXT_FIELD_WRITE_DATA &&
                    textlen > currentViewContorller.appDelegate.MAX_WRITE_DATA_LENGTH) return false;

                string a = "0123456789ABCDEFabcdef";

                if (a.IndexOf(replacementString) > -1)
                {
                    string str = textField.Text + replacementString;
                    textField.Text = str.ToUpper();
                }
                return false;
            }

        }
//#pragma mark - Getters
        NSArray OffsetPickerData()
        {
            if (_offsetPickerData == null)
            {
                NSMutableArray tmpArray = new NSMutableArray();

                foreach (string offset in appDelegate.DATA_WORD)
                {
                    string str = offset + " WORD";
                    tmpArray.Add(new NSString(str));
                }
                _offsetPickerData = tmpArray;
            }
            return _offsetPickerData;
        }
//#pragma mark - IBAction
        partial void WriteBtnTapped(NSObject _)
        {
            void ShowAlert(string message)
            {
                currentAlert = UIAlertController.Create("Error", message, UIAlertControllerStyle.Alert);
                currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                {
                    currentAlert = null;
                }));
                PresentViewController(currentAlert, true, null);
            }

            isActionResult = false;
            string messageStr = null;

            if (writeDataTextField.Text.Length % 4 != 0 || writeDataTextField.Text.Length == 0)
            {
                messageStr = "Write Data must be entered in WORD unit.(1WORD = 16-bit)";
            }
            if (writeDataTextField.Text.Length / 4 > 32)
            {
                messageStr = "Write Data cannot be exceed 32WORD.(1WORD = 16-bit)";
            }
            if (messageStr != null)
            {
                if (currentAlert != null)
                    currentAlert.DismissViewController(false, () => ShowAlert(messageStr));
                else
                    ShowAlert(messageStr);

                return;
            }

            messageLabel.Text = "Writing tag memory.\nPlease wait…";

            if (operationTimeTextField.Text == "")
                operationTimeTextField.Text = "0";

            mReader.OperationTime = int.Parse(operationTimeTextField.Text);
            systemSetting.setOperationTime(int.Parse(operationTimeTextField.Text));
            int index = Array.IndexOf(appDelegate.DATA_BANK, bankTextField.Text);
            MemoryBank bank = (MemoryBank)(uint)index;
            mReader.AccessPassword = passwordTextField.Text;
            mReader.WriteMemory(bank, offsetValue, writeDataTextField.Text);

            void ShowWaitAlert()
            {
                currentAlert = UIAlertController.Create("Please wait...", "Writing tag memory", UIAlertControllerStyle.Alert);
                currentAlert.AddAction(UIAlertAction.Create("Stop", UIAlertActionStyle.Cancel, Action =>
                {
                    StopAction();
                    currentAlert = null;
                }));
                PresentViewController(currentAlert, true, null);
            }

            if (currentAlert != null)
                currentAlert.DismissViewController(false, () => ShowWaitAlert());
            else
                ShowWaitAlert();
        }
        partial void BlockWriteBtnTapped(NSObject _)
        {
            isActionResult = false;
            messageLabel.Text = "Block writing tag memory.\nPlease wait…";

            if (operationTimeTextField.Text == "")
                operationTimeTextField.Text = "0";

            mReader.OperationTime = int.Parse(operationTimeTextField.Text);
            systemSetting.setOperationTime(int.Parse(operationTimeTextField.Text));
            int index = Array.IndexOf(appDelegate.DATA_BANK, bankTextField.Text);
            MemoryBank bank = (MemoryBank)(uint)index;
            mReader.BlockWrite(bank, offsetValue, writeDataTextField.Text);
        }
        partial void ClearBtnTapped(NSObject _)
        {
            selectionTagLabel.Text = "Result";
            messageLabel.Text = MSG_TAG_WAIT;
            rssiLabel.Text = @"0.0 dB";
            phaseLabel.Text = @"0.0˚";
        }
        partial void MaskBtnTapped(NSObject _)
        {
            if (maskType == MaskType.Selection)
                PerformSegue("SelectionMask", this);
            else
            {
                void ShowAlert()
                {
                    currentAlert = UIAlertController.Create("", "Please set the mask type in RFID Options menu before using mask.", UIAlertControllerStyle.Alert);
                    currentAlert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Cancel, Action =>
                    {
                        currentAlert = null;
                    }));
                    PresentViewController(currentAlert, true, null);
                }
                if (currentAlert != null)
                    currentAlert.DismissViewController(false, () => ShowAlert());
                else
                    ShowAlert();
            }
        }
        partial void BankBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_BANK;
            pickerView.ReloadAllComponents();

            if (bankTextField.Text != "")
            {
                int index = Array.IndexOf(appDelegate.DATA_BANK, bankTextField.Text);
                pickerView.Select((nint)index, 0, false);
            }
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            bankPickerTopView.Hidden = false;
        }
        partial void OffsetBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_OFFSET;
            pickerView.ReloadAllComponents();

            if (offsetTextField.Text != "")
                pickerView.Select((nint)OffsetPickerData().IndexOf(new NSString(offsetTextField.Text)), 0, false);
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            offsetPickerTopView.Hidden = false;
        }
        partial void WriteDataBtnTapped(NSObject _)
        {
            isEditing = TEXT_FIELD_WRITE_DATA;

            UIAlertController alert = UIAlertController.Create("Write Data:", "Please enter write data.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;
                SetWriteData(str);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void PasswordBtnTapped(NSObject _)
        {
            isEditing = TEXT_FIELD_PASSWORD;

            UIAlertController alert = UIAlertController.Create("Password", "Please enter password.", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.ASCIICapable;
                textField.Delegate = new MyTextFieldDelegate(this);
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;
                SetPassword(str);
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void PowerGainBtnTapped(NSObject _)
        {
            pickerView.Tag = PICKER_VIEW_POWER_GAIN;
            pickerView.ReloadAllComponents();

            if (powerGainTextField.Text != "")
                pickerView.Select(powerGainPickerData.IndexOf(new NSString(powerGainTextField.Text)), 0, false);
            else
                pickerView.Select(0, 0, false);

            pickerView.Hidden = false;
            powerGainPickerTopView.Hidden = false;
        }
        partial void OperationTimeBtnTapped(NSObject _)
        {
            UIAlertController alert = UIAlertController.Create("Operation Time:", "Please enter operation time.\n(ex: 30 ms)", UIAlertControllerStyle.Alert);
            alert.AddTextField(textField =>
            {
                textField.KeyboardType = UIKeyboardType.NumberPad;
            });
            alert.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, Action =>
            {
                UITextField textField = alert.TextFields[0];
                string str = textField.Text;

                if (str == "")
                    str = "0";

                SetOperationTime(str);
                mReader.OperationTime = int.Parse(str);
                systemSetting.setOperationTime(int.Parse(str));
            }));
            alert.AddAction(UIAlertAction.Create("Cancel", UIAlertActionStyle.Cancel, null));
            PresentViewController(alert, true, null);
        }
        partial void ReportRssiSwitchTapped(NSObject _)
        {
            mReader.RssiMode = reportRssiSwitch.On;
            systemSetting.setRssiMode(reportRssiSwitch.On);
            SetReportRssiModeEnabled(reportRssiSwitch.On);
        }
        partial void PickerCloseBtnTapped(NSObject _)
        {
            HidePickerView();
        }
        partial void BankPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            SetBank(idx);
            HidePickerView();
        }
        partial void OffsetPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            SetOffset(idx);
            HidePickerView();
        }
        partial void PowerGainPickerOkBtnTapped(NSObject _)
        {
            nint idx = pickerView.SelectedRowInComponent(0);
            idx += mReader.PowerGainRange.min / 10;
            SetPowerGain(idx);
            mReader.PowerGain = (int)idx * 10;
            systemSetting.setPowerGain((int)idx * 10);
            HidePickerView();
        }
//#pragma mark - Custom
        void HidePickerView()
        {
            bankPickerTopView.Hidden = true;
            offsetPickerTopView.Hidden = true;
            powerGainPickerTopView.Hidden = true;
            pickerView.Hidden = true;
        }
        void SetBank(nint index)
        {
            bankTextField.Text = appDelegate.DATA_BANK[index];
        }
        void SetOffset(nint index)
        {
            offsetTextField.Text = OffsetPickerData().GetItem<NSString>((uint)index).ToString();
            offsetValue = (int)index;
        }
        void SetWriteData(string writeData)
        {
            writeDataTextField.Text = writeData;
        }
        void SetPassword(string password)
        {
            passwordTextField.Text = password;
        }
        void SetPowerGain(nint power)
        {
            NSString value = new NSString(power.ToString() + ".0 dB");
            int index = powerGainPickerData.IndexOf(value);

            if (powerGainPickerData.Count > index)
                powerGainTextField.Text = powerGainPickerData[index];
        }
        void SetOperationTime(string operationTime)
        {
            operationTimeTextField.Text = operationTime;
        }
        void StopAction()
        {
            _ = mReader.Stop;
        }
        void SetReportRssiModeEnabled(bool enabled)
        {
            foreach (UILabel elem in reportRssiCollection)
            {
                elem.Enabled = enabled;
            }
            if (enabled == false)
            {
                SetReportRssiModeDefault();
            }
            reportRssiSwitch.On = enabled;
        }
        void SetReportRssiModeDefault()
        {
            rssiLabel.Text = "0.0 dB";
            phaseLabel.Text = "0.0˚";
        }
    }
}
